(function (root, factory) {
  if (typeof define === 'function' && define.amd)
    define(['exports', 'kotlin', 'd2v-core', 'd2v-interpolate', 'd2v-color', 'Kotlin-DateTime-library-kotlinx-datetime-js-legacy'], factory);
  else if (typeof exports === 'object')
    factory(module.exports, require('kotlin'), require('d2v-core'), require('d2v-interpolate'), require('d2v-color'), require('Kotlin-DateTime-library-kotlinx-datetime-js-legacy'));
  else {
    if (typeof kotlin === 'undefined') {
      throw new Error("Error loading module 'd2v-scale'. Its dependency 'kotlin' was not found. Please, check whether 'kotlin' is loaded prior to 'd2v-scale'.");
    }if (typeof this['d2v-core'] === 'undefined') {
      throw new Error("Error loading module 'd2v-scale'. Its dependency 'd2v-core' was not found. Please, check whether 'd2v-core' is loaded prior to 'd2v-scale'.");
    }if (typeof this['d2v-interpolate'] === 'undefined') {
      throw new Error("Error loading module 'd2v-scale'. Its dependency 'd2v-interpolate' was not found. Please, check whether 'd2v-interpolate' is loaded prior to 'd2v-scale'.");
    }if (typeof this['d2v-color'] === 'undefined') {
      throw new Error("Error loading module 'd2v-scale'. Its dependency 'd2v-color' was not found. Please, check whether 'd2v-color' is loaded prior to 'd2v-scale'.");
    }if (typeof this['Kotlin-DateTime-library-kotlinx-datetime-js-legacy'] === 'undefined') {
      throw new Error("Error loading module 'd2v-scale'. Its dependency 'Kotlin-DateTime-library-kotlinx-datetime-js-legacy' was not found. Please, check whether 'Kotlin-DateTime-library-kotlinx-datetime-js-legacy' is loaded prior to 'd2v-scale'.");
    }root['d2v-scale'] = factory(typeof this['d2v-scale'] === 'undefined' ? {} : this['d2v-scale'], kotlin, this['d2v-core'], this['d2v-interpolate'], this['d2v-color'], this['Kotlin-DateTime-library-kotlinx-datetime-js-legacy']);
  }
}(this, function (_, Kotlin, $module$d2v_core, $module$d2v_interpolate, $module$d2v_color, $module$Kotlin_DateTime_library_kotlinx_datetime_js_legacy) {
  'use strict';
  var round = Kotlin.kotlin.math.round_14dthe$;
  var reverse = Kotlin.kotlin.collections.reverse_4b5429$;
  var addAll = Kotlin.kotlin.collections.addAll_ye1y7v$;
  var kotlin_js_internal_DoubleCompanionObject = Kotlin.kotlin.js.internal.DoubleCompanionObject;
  var get_pct = $module$d2v_core.io.data2viz.math.get_pct_rcaex3$;
  var Kind_CLASS = Kotlin.Kind.CLASS;
  var Percent = $module$d2v_core.io.data2viz.math.Percent;
  var ArrayList_init = Kotlin.kotlin.collections.ArrayList_init_287e2$;
  var JsMath = Math;
  var Array_0 = Array;
  var toList = Kotlin.kotlin.collections.toList_7wnvza$;
  var getCallableRef = Kotlin.getCallableRef;
  var IllegalStateException_init = Kotlin.kotlin.IllegalStateException_init;
  var first = Kotlin.kotlin.collections.first_2p1efm$;
  var last = Kotlin.kotlin.collections.last_2p1efm$;
  var reversed = Kotlin.kotlin.collections.reversed_7wnvza$;
  var IllegalStateException_init_0 = Kotlin.kotlin.IllegalStateException_init_pdl1vj$;
  var interpolateNumber = $module$d2v_interpolate.io.data2viz.interpolate.interpolateNumber_lu1900$;
  var uninterpolateNumber = $module$d2v_interpolate.io.data2viz.interpolate.uninterpolateNumber_lu1900$;
  var tickStep = $module$d2v_core.io.data2viz.math.tickStep_syxxoe$;
  var ticks = $module$d2v_core.io.data2viz.math.ticks_syxxoe$;
  var naturalOrder = Kotlin.kotlin.comparisons.naturalOrder_dahdeg$;
  var listOf = Kotlin.kotlin.collections.listOf_i5x0yv$;
  var throwUPAE = Kotlin.throwUPAE;
  var IllegalArgumentException_init = Kotlin.kotlin.IllegalArgumentException_init_pdl1vj$;
  var log = Kotlin.kotlin.math.log_lu1900$;
  var isNaN_0 = Kotlin.kotlin.isNaN_yrwdxr$;
  var toMutableList = Kotlin.kotlin.collections.toMutableList_4c7yge$;
  var numberToInt = Kotlin.numberToInt;
  var collectionSizeOrDefault = Kotlin.kotlin.collections.collectionSizeOrDefault_ba2ldo$;
  var ArrayList_init_0 = Kotlin.kotlin.collections.ArrayList_init_ww73n8$;
  var LinkedHashMap_init = Kotlin.kotlin.collections.LinkedHashMap_init_q3lmfv$;
  var emptyList = Kotlin.kotlin.collections.emptyList_287e2$;
  var sorted = Kotlin.kotlin.collections.sorted_exjks8$;
  var mutableListOf = Kotlin.kotlin.collections.mutableListOf_i5x0yv$;
  var Kind_INTERFACE = Kotlin.Kind.INTERFACE;
  var first_0 = Kotlin.kotlin.collections.first_us0mfu$;
  var last_0 = Kotlin.kotlin.collections.last_us0mfu$;
  var Unit = Kotlin.kotlin.Unit;
  var interpolateRound = $module$d2v_interpolate.io.data2viz.interpolate.interpolateRound_lu1900$;
  var interpolatePoint = $module$d2v_interpolate.io.data2viz.interpolate.interpolatePoint_840z2k$;
  var uninterpolatePointOnX = $module$d2v_interpolate.io.data2viz.interpolate.uninterpolatePointOnX_840z2k$;
  var PointComparatorX = $module$d2v_interpolate.io.data2viz.interpolate.PointComparatorX;
  var Kind_OBJECT = Kotlin.Kind.OBJECT;
  var rgbLinearInterpolator = $module$d2v_interpolate.io.data2viz.interpolate.rgbLinearInterpolator_lu7xrq$;
  var rgbDefaultInterpolator = $module$d2v_interpolate.io.data2viz.interpolate.rgbDefaultInterpolator_lu7xrq$;
  var labInterpolator = $module$d2v_interpolate.io.data2viz.interpolate.labInterpolator_lu7xrq$;
  var hclInterpolator = $module$d2v_interpolate.io.data2viz.interpolate.hclInterpolator_lu7xrq$;
  var hclLongInterpolator = $module$d2v_interpolate.io.data2viz.interpolate.hclLongInterpolator_lu7xrq$;
  var hslInterpolator = $module$d2v_interpolate.io.data2viz.interpolate.hslInterpolator_lu7xrq$;
  var hslLongInterpolator = $module$d2v_interpolate.io.data2viz.interpolate.hslLongInterpolator_lu7xrq$;
  var EncodedColors = $module$d2v_color.io.data2viz.color.EncodedColors;
  var rgbBasisInterpolator = $module$d2v_interpolate.io.data2viz.interpolate.rgbBasisInterpolator_o5f480$;
  var rgbSineBowInterpolator = $module$d2v_interpolate.io.data2viz.interpolate.rgbSineBowInterpolator;
  var equals = Kotlin.equals;
  var listOf_0 = Kotlin.kotlin.collections.listOf_mh5how$;
  var Comparator = Kotlin.kotlin.Comparator;
  var L1000 = Kotlin.Long.fromInt(1000);
  var L60000 = Kotlin.Long.fromInt(60000);
  var L3600000 = Kotlin.Long.fromInt(3600000);
  var L86400000 = Kotlin.Long.fromInt(86400000);
  var L604800000 = Kotlin.Long.fromInt(604800000);
  var L2592000000 = new Kotlin.Long(-1702967296, 0);
  var L31536000000 = new Kotlin.Long(1471228928, 7);
  var interpolateDate = $module$d2v_interpolate.io.data2viz.interpolate.interpolateDate_53yea4$;
  var uninterpolateDate = $module$d2v_interpolate.io.data2viz.interpolate.uninterpolateDate_53yea4$;
  var TimeZone = $module$Kotlin_DateTime_library_kotlinx_datetime_js_legacy.kotlinx.datetime.TimeZone;
  var get_milliseconds = Kotlin.kotlin.time.get_milliseconds_s8ev3n$;
  var Instant = $module$Kotlin_DateTime_library_kotlinx_datetime_js_legacy.kotlinx.datetime.Instant;
  var toInstant = $module$Kotlin_DateTime_library_kotlinx_datetime_js_legacy.kotlinx.datetime.toInstant_qewd0w$;
  var periodUntil = $module$Kotlin_DateTime_library_kotlinx_datetime_js_legacy.kotlinx.datetime.periodUntil_9wlul4$;
  var plus = $module$Kotlin_DateTime_library_kotlinx_datetime_js_legacy.kotlinx.datetime.plus_ate4tl$;
  var toLocalDateTime = $module$Kotlin_DateTime_library_kotlinx_datetime_js_legacy.kotlinx.datetime.toLocalDateTime_pneqz9$;
  var LocalDateTime_init = $module$Kotlin_DateTime_library_kotlinx_datetime_js_legacy.kotlinx.datetime.LocalDateTime_init_ui44o2$;
  var L0 = Kotlin.Long.ZERO;
  var get_days = Kotlin.kotlin.time.get_days_s8ev3n$;
  var DateTimeUnit = $module$Kotlin_DateTime_library_kotlinx_datetime_js_legacy.kotlinx.datetime.DateTimeUnit;
  var until = $module$Kotlin_DateTime_library_kotlinx_datetime_js_legacy.kotlinx.datetime.until_ur76pz$;
  var get_hours = Kotlin.kotlin.time.get_hours_s8ev3n$;
  var get_minutes = Kotlin.kotlin.time.get_minutes_s8ev3n$;
  var DateTimePeriod = $module$Kotlin_DateTime_library_kotlinx_datetime_js_legacy.kotlinx.datetime.DateTimePeriod_m758o9$;
  var monthsUntil = $module$Kotlin_DateTime_library_kotlinx_datetime_js_legacy.kotlinx.datetime.monthsUntil_9wlul4$;
  var get_seconds = Kotlin.kotlin.time.get_seconds_s8ev3n$;
  var LocalDateTime_init_0 = $module$Kotlin_DateTime_library_kotlinx_datetime_js_legacy.kotlinx.datetime.LocalDateTime_init_3msazk$;
  var yearsUntil = $module$Kotlin_DateTime_library_kotlinx_datetime_js_legacy.kotlinx.datetime.yearsUntil_9wlul4$;
  BandScale.prototype = Object.create(BandedScale.prototype);
  BandScale.prototype.constructor = BandScale;
  PointScale.prototype = Object.create(BandedScale.prototype);
  PointScale.prototype.constructor = PointScale;
  LinearScale.prototype = Object.create(ContinuousScale.prototype);
  LinearScale.prototype.constructor = LinearScale;
  LogScale.prototype = Object.create(LinearScale.prototype);
  LogScale.prototype.constructor = LogScale;
  PowerScale.prototype = Object.create(LinearScale.prototype);
  PowerScale.prototype.constructor = PowerScale;
  TimeScale.prototype = Object.create(ContinuousScale.prototype);
  TimeScale.prototype.constructor = TimeScale;
  Day.prototype = Object.create(Interval.prototype);
  Day.prototype.constructor = Day;
  Hour.prototype = Object.create(Interval.prototype);
  Hour.prototype.constructor = Hour;
  Millisecond.prototype = Object.create(Interval.prototype);
  Millisecond.prototype.constructor = Millisecond;
  Minute.prototype = Object.create(Interval.prototype);
  Minute.prototype.constructor = Minute;
  Month.prototype = Object.create(Interval.prototype);
  Month.prototype.constructor = Month;
  Second.prototype = Object.create(Interval.prototype);
  Second.prototype.constructor = Second;
  Weekday.prototype = Object.create(Interval.prototype);
  Weekday.prototype.constructor = Weekday;
  Year.prototype = Object.create(Interval.prototype);
  Year.prototype.constructor = Year;
  function BandedScale(indexableDomain) {
    if (indexableDomain === void 0)
      indexableDomain = new IndexableDomain();
    this.indexableDomain_u45y1f$_0 = indexableDomain;
    this.unknown_plmz65$_0 = kotlin_js_internal_DoubleCompanionObject.NaN;
    this._paddingInner = 0.0;
    this._paddingOuter = 0.0;
    this.range_ypyoio$_0 = intervalOf(0.0, 1.0);
    this.round_yxsewf$_0 = false;
    this.align_qu5nmg$_0 = get_pct(50);
    this.step_o22tfv$_0 = 1.0;
    this.bandwidth_ciwtgs$_0 = 1.0;
    this.ordinalRange_ft5nn9$_0 = ArrayList_init();
  }
  Object.defineProperty(BandedScale.prototype, 'domain', {
    configurable: true,
    get: function () {
      return this.indexableDomain_u45y1f$_0._domain_8be2vx$;
    },
    set: function (value) {
      this.indexableDomain_u45y1f$_0.domain = value;
      this.rescale();
    }
  });
  Object.defineProperty(BandedScale.prototype, 'range', {
    configurable: true,
    get: function () {
      return this.range_ypyoio$_0;
    },
    set: function (value) {
      this.range_ypyoio$_0 = value;
      this.rescale();
    }
  });
  Object.defineProperty(BandedScale.prototype, 'round', {
    configurable: true,
    get: function () {
      return this.round_yxsewf$_0;
    },
    set: function (value) {
      this.round_yxsewf$_0 = value;
      this.rescale();
    }
  });
  Object.defineProperty(BandedScale.prototype, 'align', {
    configurable: true,
    get: function () {
      return this.align_qu5nmg$_0;
    },
    set: function (value) {
      this.align_qu5nmg$_0 = value.coerceToDefault();
      this.rescale();
    }
  });
  Object.defineProperty(BandedScale.prototype, 'step', {
    configurable: true,
    get: function () {
      return this.step_o22tfv$_0;
    },
    set: function (step) {
      this.step_o22tfv$_0 = step;
    }
  });
  Object.defineProperty(BandedScale.prototype, 'bandwidth', {
    configurable: true,
    get: function () {
      return this.bandwidth_ciwtgs$_0;
    },
    set: function (bandwidth) {
      this.bandwidth_ciwtgs$_0 = bandwidth;
    }
  });
  BandedScale.prototype.invoke_11rb$ = function (domainValue) {
    var tmp$;
    tmp$ = this.indexableDomain_u45y1f$_0.index_8be2vx$.get_11rb$(domainValue);
    if (tmp$ == null) {
      return this.unknown_plmz65$_0;
    }var i = tmp$;
    return this.ordinalRange_ft5nn9$_0.isEmpty() ? this.unknown_plmz65$_0 : this.ordinalRange_ft5nn9$_0.get_za3lpa$(i);
  };
  BandedScale.prototype.ticks_za3lpa$$default = function (count) {
    return this.domain;
  };
  BandedScale.prototype.rescale = function () {
    var n = this.indexableDomain_u45y1f$_0._domain_8be2vx$.size;
    var reverse_0 = this.range.end < this.range.start;
    var start = {v: reverse_0 ? this.range.end : this.range.start};
    var stop = reverse_0 ? this.range.start : this.range.end;
    var tmp$ = stop - start.v;
    var b = n - this._paddingInner + this._paddingOuter * 2;
    this.step = tmp$ / JsMath.max(1.0, b);
    if (this.round) {
      var x = this.step;
      this.step = JsMath.floor(x);
    }start.v += (stop - start.v - this.step * (n - this._paddingInner)) * this.align.value;
    this.bandwidth = this.step * (1 - this._paddingInner);
    if (this.round) {
      start.v = round(start.v);
      this.bandwidth = round(this.bandwidth);
    }var array = Array_0(n);
    var tmp$_0;
    tmp$_0 = array.length - 1 | 0;
    for (var i = 0; i <= tmp$_0; i++) {
      array[i] = start.v + this.step * i;
    }
    var values = array;
    if (reverse_0)
      reverse(values);
    this.ordinalRange_ft5nn9$_0.clear();
    addAll(this.ordinalRange_ft5nn9$_0, values);
  };
  BandedScale.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'BandedScale',
    interfaces: [StrictlyContinuousRange, Tickable, DiscreteDomain, Scale]
  };
  function BandScale() {
    BandedScale.call(this);
  }
  Object.defineProperty(BandScale.prototype, 'padding', {
    configurable: true,
    get: function () {
      return new Percent(this._paddingInner);
    },
    set: function (value) {
      this._paddingInner = value.value;
      this._paddingOuter = value.value;
      this.rescale();
    }
  });
  Object.defineProperty(BandScale.prototype, 'paddingInner', {
    configurable: true,
    get: function () {
      return new Percent(this._paddingInner);
    },
    set: function (value) {
      this._paddingInner = value.coerceToDefault().value;
      this.rescale();
    }
  });
  Object.defineProperty(BandScale.prototype, 'paddingOuter', {
    configurable: true,
    get: function () {
      return new Percent(this._paddingOuter);
    },
    set: function (value) {
      this._paddingOuter = value.coerceToDefault().value;
      this.rescale();
    }
  });
  BandScale.prototype.copy = function () {
    var $receiver = new BandScale();
    $receiver.align = this.align;
    $receiver.domain = this.domain;
    $receiver.range = this.range;
    $receiver.round = this.round;
    $receiver.padding = this.padding;
    $receiver.paddingInner = this.paddingInner;
    $receiver.paddingOuter = this.paddingOuter;
    $receiver.rescale();
    return $receiver;
  };
  BandScale.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'BandScale',
    interfaces: [BandedScale]
  };
  function PointScale() {
    BandedScale.call(this);
    this._paddingInner = 1.0;
    this.rescale();
  }
  Object.defineProperty(PointScale.prototype, 'padding', {
    configurable: true,
    get: function () {
      return new Percent(this._paddingOuter);
    },
    set: function (value) {
      this._paddingOuter = value.coerceToDefault().value;
      this.rescale();
    }
  });
  PointScale.prototype.copy = function () {
    var $receiver = new PointScale();
    $receiver.align = this.align;
    $receiver.domain = this.domain;
    $receiver.range = this.range;
    $receiver.round = this.round;
    $receiver.padding = this.padding;
    $receiver.rescale();
    return $receiver;
  };
  PointScale.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'PointScale',
    interfaces: [BandedScale]
  };
  function ContinuousScale(interpolateRange, uninterpolateRange, rangeComparator) {
    if (uninterpolateRange === void 0)
      uninterpolateRange = null;
    if (rangeComparator === void 0)
      rangeComparator = null;
    this.interpolateRange = interpolateRange;
    this.uninterpolateRange = uninterpolateRange;
    this.rangeComparator = rangeComparator;
    this.rangeToDomain_wybcqs$_0 = null;
    this.domainToRange_mi7vq2$_0 = null;
    this._domain = ArrayList_init();
    this._range = ArrayList_init();
    this.clamp_v0itnn$_0 = false;
  }
  Object.defineProperty(ContinuousScale.prototype, 'clamp', {
    configurable: true,
    get: function () {
      return this.clamp_v0itnn$_0;
    },
    set: function (value) {
      this.clamp_v0itnn$_0 = value;
      this.rescale();
    }
  });
  Object.defineProperty(ContinuousScale.prototype, 'domain', {
    configurable: true,
    get: function () {
      return toList(this._domain);
    },
    set: function (value) {
      this._domain.clear();
      this._domain.addAll_brywnq$(value);
      this.rescale();
    }
  });
  Object.defineProperty(ContinuousScale.prototype, 'range', {
    configurable: true,
    get: function () {
      return toList(this._range);
    },
    set: function (value) {
      this._range.clear();
      this._range.addAll_brywnq$(value);
      this.rescale();
    }
  });
  ContinuousScale.prototype.invoke_11rb$ = function (domainValue) {
    var tmp$, tmp$_0;
    if (this.domainToRange_mi7vq2$_0 == null) {
      if (!(this._domain.size === this._range.size)) {
        var message = 'Domains (in) and Ranges (out) must have the same size.';
        throw IllegalStateException_init_0(message.toString());
      }var uninterpolateFunc = this.clamp ? this.uninterpolateClamp_mkwol2$_0(getCallableRef('uninterpolateDomain', function ($receiver, p1, p2) {
        return $receiver.uninterpolateDomain_xwzc9q$(p1, p2);
      }.bind(null, this))) : getCallableRef('uninterpolateDomain', function ($receiver, p1, p2) {
        return $receiver.uninterpolateDomain_xwzc9q$(p1, p2);
      }.bind(null, this));
      this.domainToRange_mi7vq2$_0 = this._domain.size > 2 ? this.polymap_z4navf$_0(uninterpolateFunc) : this.bimap_bn0tgw$_0(uninterpolateFunc);
    }tmp$_0 = (tmp$ = this.domainToRange_mi7vq2$_0) != null ? tmp$(domainValue) : null;
    if (tmp$_0 == null) {
      throw IllegalStateException_init();
    }return tmp$_0;
  };
  ContinuousScale.prototype.invert_11rc$ = function (rangeValue) {
    var tmp$, tmp$_0;
    if (this.uninterpolateRange == null) {
      var message = 'No de-interpolation function for range has been found for this scale. Invert operation is impossible.';
      throw IllegalStateException_init_0(message.toString());
    }if (this.rangeToDomain_wybcqs$_0 == null) {
      if (!(this._domain.size === this._range.size)) {
        var message_0 = 'Domains (in) and Ranges (out) must have the same size.';
        throw IllegalStateException_init_0(message_0.toString());
      }var interpolateFunc = this.clamp ? this.interpolateClamp_6w93zt$_0(getCallableRef('interpolateDomain', function ($receiver, p1, p2) {
        return $receiver.interpolateDomain_xwzc9q$(p1, p2);
      }.bind(null, this))) : getCallableRef('interpolateDomain', function ($receiver, p1, p2) {
        return $receiver.interpolateDomain_xwzc9q$(p1, p2);
      }.bind(null, this));
      this.rangeToDomain_wybcqs$_0 = this._domain.size > 2 || this._range.size > 2 ? this.polymapInvert_1hhkox$_0(interpolateFunc, this.uninterpolateRange) : this.bimapInvert_bfo0f0$_0(interpolateFunc, this.uninterpolateRange);
    }tmp$_0 = (tmp$ = this.rangeToDomain_wybcqs$_0) != null ? tmp$(rangeValue) : null;
    if (tmp$_0 == null) {
      throw IllegalStateException_init();
    }return tmp$_0;
  };
  ContinuousScale.prototype.rescale = function () {
    this.rangeToDomain_wybcqs$_0 = null;
    this.domainToRange_mi7vq2$_0 = null;
  };
  function ContinuousScale$uninterpolateClamp$lambda$lambda(closure$d) {
    return function (value) {
      return closure$d(value).coerceToDefault();
    };
  }
  function ContinuousScale$uninterpolateClamp$lambda(closure$uninterpolateFunction) {
    return function (a, b) {
      var d = closure$uninterpolateFunction(a, b);
      return ContinuousScale$uninterpolateClamp$lambda$lambda(d);
    };
  }
  ContinuousScale.prototype.uninterpolateClamp_mkwol2$_0 = function (uninterpolateFunction) {
    return ContinuousScale$uninterpolateClamp$lambda(uninterpolateFunction);
  };
  function ContinuousScale$interpolateClamp$lambda$lambda(closure$r) {
    return function (value) {
      return closure$r(value.coerceToDefault());
    };
  }
  function ContinuousScale$interpolateClamp$lambda(closure$interpolateFunction) {
    return function (a, b) {
      var r = closure$interpolateFunction(a, b);
      return ContinuousScale$interpolateClamp$lambda$lambda(r);
    };
  }
  ContinuousScale.prototype.interpolateClamp_6w93zt$_0 = function (interpolateFunction) {
    return ContinuousScale$interpolateClamp$lambda(interpolateFunction);
  };
  function ContinuousScale$bimap$lambda(closure$r, closure$d) {
    return function (x) {
      return closure$r(closure$d(x));
    };
  }
  ContinuousScale.prototype.bimap_bn0tgw$_0 = function (deinterpolateDomain) {
    var d0 = this._domain.get_za3lpa$(0);
    var d1 = this._domain.get_za3lpa$(1);
    var r0 = this._range.get_za3lpa$(0);
    var r1 = this._range.get_za3lpa$(1);
    var r;
    var d;
    if (this.domainComparator().compare(d1, d0) < 0) {
      d = deinterpolateDomain(d1, d0);
      r = this.interpolateRange(r1, r0);
    } else {
      d = deinterpolateDomain(d0, d1);
      r = this.interpolateRange(r0, r1);
    }
    return ContinuousScale$bimap$lambda(r, d);
  };
  function ContinuousScale$bimapInvert$lambda(closure$d, closure$r) {
    return function (x) {
      return closure$d(closure$r(x));
    };
  }
  ContinuousScale.prototype.bimapInvert_bfo0f0$_0 = function (reinterpolateDomain, deinterpolateRange) {
    if (this.rangeComparator == null) {
      var message = 'No RangeComparator has been found for this scale. Invert operation is impossible.';
      throw IllegalStateException_init_0(message.toString());
    }var d0 = this._domain.get_za3lpa$(0);
    var d1 = this._domain.get_za3lpa$(1);
    var r0 = this._range.get_za3lpa$(0);
    var r1 = this._range.get_za3lpa$(1);
    var r;
    var d;
    if (this.rangeComparator.compare(r1, r0) < 0) {
      d = reinterpolateDomain(d1, d0);
      r = deinterpolateRange(r1, r0);
    } else {
      d = reinterpolateDomain(d0, d1);
      r = deinterpolateRange(r0, r1);
    }
    return ContinuousScale$bimapInvert$lambda(d, r);
  };
  function ContinuousScale$polymap$lambda(this$ContinuousScale, closure$size, closure$rangeInterpolators, closure$domainInterpolators) {
    return function (x) {
      var index = bisectRight(this$ContinuousScale._domain, x, this$ContinuousScale.domainComparator(), 1, closure$size) - 1 | 0;
      return closure$rangeInterpolators[index](closure$domainInterpolators[index](x));
    };
  }
  ContinuousScale.prototype.polymap_z4navf$_0 = function (uninterpolateDomain) {
    var d0 = first(this._domain);
    var d1 = last(this._domain);
    var domainReversed = this.domainComparator().compare(d1, d0) < 0;
    var domainValues = domainReversed ? reversed(this._domain) : this._domain;
    var rangeValues = domainReversed ? reversed(this._range) : this._range;
    var a = this._domain.size;
    var b = this._range.size;
    var size = JsMath.min(a, b) - 1 | 0;
    var array = Array_0(size);
    var tmp$;
    tmp$ = array.length - 1 | 0;
    for (var i = 0; i <= tmp$; i++) {
      array[i] = uninterpolateDomain(domainValues.get_za3lpa$(i), domainValues.get_za3lpa$(i + 1 | 0));
    }
    var domainInterpolators = array;
    var array_0 = Array_0(size);
    var tmp$_0;
    tmp$_0 = array_0.length - 1 | 0;
    for (var i_0 = 0; i_0 <= tmp$_0; i_0++) {
      array_0[i_0] = this.interpolateRange(rangeValues.get_za3lpa$(i_0), rangeValues.get_za3lpa$(i_0 + 1 | 0));
    }
    var rangeInterpolators = array_0;
    return ContinuousScale$polymap$lambda(this, size, rangeInterpolators, domainInterpolators);
  };
  function ContinuousScale$polymapInvert$lambda(closure$rangeValues, this$ContinuousScale, closure$size, closure$domainInterpolators, closure$rangeInterpolators) {
    return function (y) {
      var index = bisectRight(closure$rangeValues, y, this$ContinuousScale.rangeComparator, 1, closure$size) - 1 | 0;
      return closure$domainInterpolators[index](closure$rangeInterpolators[index](y));
    };
  }
  ContinuousScale.prototype.polymapInvert_1hhkox$_0 = function (interpolateDomain, uninterpolateRange) {
    if (this.rangeComparator == null) {
      var message = 'No RangeComparator has been found for this scale. Invert operation is impossible.';
      throw IllegalStateException_init_0(message.toString());
    }var r0 = first(this._range);
    var r1 = last(this._range);
    var rangeReversed = this.rangeComparator.compare(r1, r0) < 0;
    var domainValues = rangeReversed ? reversed(this._domain) : this._domain;
    var rangeValues = rangeReversed ? reversed(this._range) : this._range;
    var a = this._domain.size;
    var b = this._range.size;
    var size = JsMath.min(a, b) - 1 | 0;
    var array = Array_0(size);
    var tmp$;
    tmp$ = array.length - 1 | 0;
    for (var i = 0; i <= tmp$; i++) {
      array[i] = interpolateDomain(domainValues.get_za3lpa$(i), domainValues.get_za3lpa$(i + 1 | 0));
    }
    var domainInterpolators = array;
    var array_0 = Array_0(size);
    var tmp$_0;
    tmp$_0 = array_0.length - 1 | 0;
    for (var i_0 = 0; i_0 <= tmp$_0; i_0++) {
      array_0[i_0] = uninterpolateRange(rangeValues.get_za3lpa$(i_0), rangeValues.get_za3lpa$(i_0 + 1 | 0));
    }
    var rangeInterpolators = array_0;
    return ContinuousScale$polymapInvert$lambda(rangeValues, this, size, domainInterpolators, rangeInterpolators);
  };
  ContinuousScale.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'ContinuousScale',
    interfaces: [InvertableScale, ClampableScale, ContinuousRangeScale, ContinuousDomain]
  };
  function bisectRight(list, x, comparator, low, high) {
    if (low === void 0)
      low = 0;
    if (high === void 0)
      high = list.size;
    var lo = low;
    var hi = high;
    while (lo < hi) {
      var mid = (lo + hi | 0) / 2 | 0;
      if (comparator.compare(list.get_za3lpa$(mid), x) > 0)
        hi = mid;
      else
        lo = mid + 1 | 0;
    }
    return lo;
  }
  function bisectLeft(list, x, comparator, low, high) {
    if (low === void 0)
      low = 0;
    if (high === void 0)
      high = list.size;
    var lo = low;
    var hi = high;
    while (lo < hi) {
      var mid = (lo + hi | 0) / 2 | 0;
      if (comparator.compare(list.get_za3lpa$(mid), x) < 0)
        lo = mid + 1 | 0;
      else
        hi = mid;
    }
    return lo;
  }
  function LinearScale(interpolateRange, uninterpolateRange, rangeComparator) {
    if (uninterpolateRange === void 0)
      uninterpolateRange = null;
    if (rangeComparator === void 0)
      rangeComparator = null;
    ContinuousScale.call(this, interpolateRange, uninterpolateRange, rangeComparator);
    this.comparator = naturalOrder();
    this._domain.clear();
    this._domain.addAll_brywnq$(listOf([0.0, 1.0]));
  }
  LinearScale.prototype.interpolateDomain_xwzc9q$ = function (from, to) {
    return interpolateNumber(from, to);
  };
  LinearScale.prototype.uninterpolateDomain_xwzc9q$ = function (from, to) {
    return uninterpolateNumber(from, to);
  };
  LinearScale.prototype.domainComparator = function () {
    return this.comparator;
  };
  LinearScale.prototype.invoke_za3lpa$ = function (domainValue) {
    return this.invoke_11rb$(domainValue);
  };
  LinearScale.prototype.nice_za3lpa$$default = function (count) {
    var last = this._domain.size - 1 | 0;
    var step = tickStep(this._domain.get_za3lpa$(0), this._domain.get_za3lpa$(last), count);
    var x = this._domain.get_za3lpa$(0) / step;
    var start = JsMath.floor(x) * step;
    var x_0 = this._domain.get_za3lpa$(last) / step;
    var stop = JsMath.ceil(x_0) * step;
    if (step !== 0.0) {
      step = tickStep(start, stop, count);
      var tmp$ = this._domain;
      var x_1 = start / step;
      tmp$.set_wxm5ur$(0, JsMath.floor(x_1) * step);
      var tmp$_0 = this._domain;
      var x_2 = stop / step;
      tmp$_0.set_wxm5ur$(last, JsMath.ceil(x_2) * step);
      this.rescale();
    }};
  LinearScale.prototype.ticks_za3lpa$$default = function (count) {
    return ticks(first(this._domain), last(this._domain), count);
  };
  LinearScale.prototype.copy = function () {
    var $receiver = new LinearScale(this.interpolateRange, this.uninterpolateRange, this.rangeComparator);
    $receiver.domain = this.domain;
    $receiver.range = this.range;
    $receiver.clamp = this.clamp;
    return $receiver;
  };
  LinearScale.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'LinearScale',
    interfaces: [NiceableScale, Tickable, ContinuousScale]
  };
  function LogScale(base, interpolateRange, uninterpolateRange, rangeComparator) {
    if (base === void 0)
      base = 10.0;
    if (uninterpolateRange === void 0)
      uninterpolateRange = null;
    if (rangeComparator === void 0)
      rangeComparator = null;
    LinearScale.call(this, interpolateRange, uninterpolateRange, rangeComparator);
    this.innerLog_dd4ihb$_ctrxix$_0 = this.innerLog_dd4ihb$_ctrxix$_0;
    this.innerPow_dd72t7$_u1pt64$_0 = this.innerPow_dd72t7$_u1pt64$_0;
    this.base_ptcf2s$_0 = base;
    this._domain.clear();
    this._domain.addAll_brywnq$(listOf([1.0, 10.0]));
    this._range.clear();
    this._range.addAll_brywnq$(listOf([0.0, 1.0]));
  }
  Object.defineProperty(LogScale.prototype, 'innerLog_dd4ihb$_0', {
    configurable: true,
    get: function () {
      if (this.innerLog_dd4ihb$_ctrxix$_0 == null)
        return throwUPAE('innerLog');
      return this.innerLog_dd4ihb$_ctrxix$_0;
    },
    set: function (innerLog) {
      this.innerLog_dd4ihb$_ctrxix$_0 = innerLog;
    }
  });
  Object.defineProperty(LogScale.prototype, 'innerPow_dd72t7$_0', {
    configurable: true,
    get: function () {
      if (this.innerPow_dd72t7$_u1pt64$_0 == null)
        return throwUPAE('innerPow');
      return this.innerPow_dd72t7$_u1pt64$_0;
    },
    set: function (innerPow) {
      this.innerPow_dd72t7$_u1pt64$_0 = innerPow;
    }
  });
  Object.defineProperty(LogScale.prototype, 'base', {
    configurable: true,
    get: function () {
      return this.base_ptcf2s$_0;
    },
    set: function (value) {
      this.base_ptcf2s$_0 = value;
      this.rescale();
    }
  });
  Object.defineProperty(LogScale.prototype, 'domain', {
    configurable: true,
    get: function () {
      return this._domain;
    },
    set: function (value) {
      var containPositive = first(value) > 0.0;
      var tmp$;
      tmp$ = value.iterator();
      while (tmp$.hasNext()) {
        var element = tmp$.next();
        if (element === 0.0)
          throw IllegalArgumentException_init('The domain interval must not contain 0, as log(0) = -\u221E.');
        if (containPositive && element < 0.0 || (!containPositive && element > 0.0))
          throw IllegalArgumentException_init('The domain interval must contain only positive or negative elements.');
      }
      this._domain.clear();
      this._domain.addAll_brywnq$(value);
      this.rescale();
    }
  });
  function LogScale$rescale$lambda(this$LogScale) {
    return function (it) {
      return -log(-it, this$LogScale.base);
    };
  }
  function LogScale$rescale$lambda_0(this$LogScale) {
    return function (it) {
      var $receiver = this$LogScale.base;
      var x = -it;
      return -JsMath.pow($receiver, x);
    };
  }
  function LogScale$rescale$lambda_1(this$LogScale) {
    return function (it) {
      return log(it, this$LogScale.base);
    };
  }
  function LogScale$rescale$lambda_2(this$LogScale) {
    return function (it) {
      var $receiver = this$LogScale.base;
      return JsMath.pow($receiver, it);
    };
  }
  LogScale.prototype.rescale = function () {
    LinearScale.prototype.rescale.call(this);
    if (first(this._domain) < 0) {
      this.innerLog_dd4ihb$_0 = LogScale$rescale$lambda(this);
      this.innerPow_dd72t7$_0 = LogScale$rescale$lambda_0(this);
    } else {
      this.innerLog_dd4ihb$_0 = LogScale$rescale$lambda_1(this);
      this.innerPow_dd72t7$_0 = LogScale$rescale$lambda_2(this);
    }
  };
  function LogScale$uninterpolateDomain$lambda(closure$from, closure$diff) {
    return function (t) {
      var x = t / closure$from;
      return new Percent(JsMath.log(x) / closure$diff);
    };
  }
  function LogScale$uninterpolateDomain$lambda_0(f) {
    return get_pct(0);
  }
  LogScale.prototype.uninterpolateDomain_xwzc9q$ = function (from, to) {
    var x = to / from;
    var diff = JsMath.log(x);
    return diff !== 0.0 && !isNaN_0(diff) ? LogScale$uninterpolateDomain$lambda(from, diff) : LogScale$uninterpolateDomain$lambda_0;
  };
  function LogScale$interpolateDomain$lambda(closure$to, closure$from) {
    return function (t) {
      var $receiver = closure$to;
      var x = t.value;
      var tmp$ = -JsMath.pow($receiver, x);
      var $receiver_0 = closure$from;
      var x_0 = 1 - t.value;
      return -(tmp$ * -JsMath.pow($receiver_0, x_0));
    };
  }
  function LogScale$interpolateDomain$lambda_0(closure$to, closure$from) {
    return function (t) {
      var $receiver = closure$to;
      var x = t.value;
      var tmp$ = JsMath.pow($receiver, x);
      var $receiver_0 = closure$from;
      var x_0 = 1 - t.value;
      return tmp$ * JsMath.pow($receiver_0, x_0);
    };
  }
  LogScale.prototype.interpolateDomain_xwzc9q$ = function (from, to) {
    return from < 0 ? LogScale$interpolateDomain$lambda(to, from) : LogScale$interpolateDomain$lambda_0(to, from);
  };
  LogScale.prototype.niceLogScale_jfu4ld$_0 = function (values, floor, ceil) {
    var reversed = last(values) < first(values);
    var first_0 = reversed ? values.size - 1 | 0 : 0;
    var last_0 = reversed ? 0 : values.size - 1 | 0;
    var newDomain = toMutableList(values);
    newDomain.set_wxm5ur$(first_0, floor(values.get_za3lpa$(first_0)));
    newDomain.set_wxm5ur$(last_0, ceil(values.get_za3lpa$(last_0)));
    return newDomain;
  };
  LogScale.prototype.copy = function () {
    var $receiver = new LogScale(this.base, this.interpolateRange, this.uninterpolateRange, this.rangeComparator);
    $receiver.domain = this.domain;
    $receiver.range = this.range;
    $receiver.clamp = this.clamp;
    return $receiver;
  };
  function LogScale$nice$lambda(this$LogScale) {
    return function (x) {
      var tmp$ = this$LogScale;
      var tmp$_0 = tmp$.innerPow_dd72t7$_0;
      var x_0 = this$LogScale.innerLog_dd4ihb$_0(x);
      return tmp$_0.call(tmp$, JsMath.floor(x_0));
    };
  }
  function LogScale$nice$lambda_0(this$LogScale) {
    return function (x) {
      var tmp$ = this$LogScale;
      var tmp$_0 = tmp$.innerPow_dd72t7$_0;
      var x_0 = this$LogScale.innerLog_dd4ihb$_0(x);
      return tmp$_0.call(tmp$, JsMath.ceil(x_0));
    };
  }
  LogScale.prototype.nice_za3lpa$$default = function (count) {
    this.domain = this.niceLogScale_jfu4ld$_0(this.domain, LogScale$nice$lambda(this), LogScale$nice$lambda_0(this));
  };
  LogScale.prototype.ticks_za3lpa$$default = function (count) {
    var tmp$;
    var domainStart = first(this._domain);
    var domainEnd = last(this._domain);
    var domainReversed = domainEnd < domainStart;
    if (domainReversed) {
      domainStart = last(this._domain);
      domainEnd = first(this._domain);
    }var logStart = this.innerLog_dd4ihb$_0(domainStart);
    var logEnd = this.innerLog_dd4ihb$_0(domainEnd);
    var tickList = ArrayList_init();
    var integerBase = this.base % 1.0 === 0.0 || isNaN_0(this.base % 1.0);
    if (integerBase && logEnd - logStart < count) {
      var x = logStart;
      logStart = JsMath.floor(x);
      var x_0 = logEnd;
      logEnd = JsMath.ceil(x_0);
      if (domainStart > 0) {
        while (logStart <= logEnd) {
          var p = this.innerPow_dd72t7$_0(logStart);
          tmp$ = numberToInt(this.base);
          for (var k = 1; k < tmp$; k++) {
            var t = p * k;
            if (t < domainStart)
              continue;
            if (t > domainEnd)
              break;
            tickList.add_11rb$(t);
          }
          logStart = logStart + 1;
        }
      } else {
        while (logStart <= logEnd) {
          var p_0 = this.innerPow_dd72t7$_0(logStart);
          for (var k_0 = numberToInt(this.base - 1); k_0 >= 1; k_0--) {
            var t_0 = p_0 * k_0;
            if (t_0 < domainStart)
              continue;
            if (t_0 > domainEnd)
              break;
            tickList.add_11rb$(t_0);
          }
          logStart = logStart + 1;
        }
      }
      if ((tickList.size * 2 | 0) < count)
        tickList = toMutableList(ticks(domainStart, domainEnd, count));
    } else {
      var tmp$_0 = logStart;
      var tmp$_1 = logEnd;
      var a = numberToInt(logEnd - logStart);
      var $receiver = ticks(tmp$_0, tmp$_1, JsMath.min(a, count));
      var destination = ArrayList_init_0(collectionSizeOrDefault($receiver, 10));
      var tmp$_2;
      tmp$_2 = $receiver.iterator();
      while (tmp$_2.hasNext()) {
        var item = tmp$_2.next();
        destination.add_11rb$(this.innerPow_dd72t7$_0(item));
      }
      tickList = toMutableList(destination);
    }
    return domainReversed ? reversed(tickList) : tickList;
  };
  LogScale.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'LogScale',
    interfaces: [LinearScale]
  };
  function IndexableDomain() {
    this.index_8be2vx$ = LinkedHashMap_init();
    this._domain_8be2vx$ = ArrayList_init();
  }
  Object.defineProperty(IndexableDomain.prototype, 'domain', {
    configurable: true,
    get: function () {
      return toList(this._domain_8be2vx$);
    },
    set: function (value) {
      this._domain_8be2vx$.clear();
      this.index_8be2vx$.clear();
      var tmp$;
      tmp$ = value.iterator();
      while (tmp$.hasNext()) {
        var element = tmp$.next();
        if (!this.index_8be2vx$.containsKey_11rb$(element)) {
          this._domain_8be2vx$.add_11rb$(element);
          this.index_8be2vx$.put_xwzc9p$(element, this._domain_8be2vx$.size - 1 | 0);
        }}
    }
  });
  IndexableDomain.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'IndexableDomain',
    interfaces: [DiscreteDomain]
  };
  function OrdinalScale(range, indexableDomain) {
    if (range === void 0) {
      range = emptyList();
    }if (indexableDomain === void 0)
      indexableDomain = new IndexableDomain();
    this.indexableDomain = indexableDomain;
    this._range = ArrayList_init();
    this._range.addAll_brywnq$(toList(range));
    this._unknown_383taz$_0 = null;
  }
  Object.defineProperty(OrdinalScale.prototype, 'range', {
    configurable: true,
    get: function () {
      return toList(this._range);
    },
    set: function (value) {
      if (!!value.isEmpty()) {
        var message = "Range can't be empty.";
        throw IllegalArgumentException_init(message.toString());
      }this._range.clear();
      this._range.addAll_brywnq$(toList(value));
    }
  });
  Object.defineProperty(OrdinalScale.prototype, 'unknown', {
    configurable: true,
    get: function () {
      return this._unknown_383taz$_0;
    },
    set: function (value) {
      this._unknown_383taz$_0 = value;
    }
  });
  OrdinalScale.prototype.invoke_11rb$ = function (domainValue) {
    var tmp$, tmp$_0, tmp$_1, tmp$_2;
    if (this._unknown_383taz$_0 == null && !this.indexableDomain.index_8be2vx$.containsKey_11rb$(domainValue)) {
      this.indexableDomain._domain_8be2vx$.add_11rb$(domainValue);
      this.indexableDomain.index_8be2vx$.put_xwzc9p$(domainValue, this.indexableDomain._domain_8be2vx$.size - 1 | 0);
    }tmp$_0 = this.indexableDomain.index_8be2vx$.get_11rb$(domainValue);
    if (tmp$_0 == null) {
      tmp$ = this._unknown_383taz$_0;
      if (tmp$ == null) {
        throw IllegalStateException_init();
      }return tmp$;
    }var index = tmp$_0;
    if (this._range.isEmpty()) {
      tmp$_1 = this._unknown_383taz$_0;
      if (tmp$_1 == null) {
        throw IllegalStateException_init();
      }tmp$_2 = tmp$_1;
    } else
      tmp$_2 = this._range.get_za3lpa$(index % this._range.size);
    return tmp$_2;
  };
  OrdinalScale.prototype.start = function () {
    return first(this.range);
  };
  OrdinalScale.prototype.end = function () {
    return last(this.range);
  };
  OrdinalScale.prototype.copy = function () {
    var $receiver = new OrdinalScale(this.range, this.indexableDomain);
    $receiver.domain = this.domain;
    return $receiver;
  };
  Object.defineProperty(OrdinalScale.prototype, 'domain', {
    configurable: true,
    get: function () {
      return this.indexableDomain.domain;
    },
    set: function (tmp$) {
      this.indexableDomain.domain = tmp$;
    }
  });
  OrdinalScale.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'OrdinalScale',
    interfaces: [FirstLastRange, DiscreteDomain, Scale]
  };
  function PowerScale(exponent, interpolateRange, uninterpolateRange, rangeComparator) {
    if (exponent === void 0)
      exponent = 1.0;
    if (uninterpolateRange === void 0)
      uninterpolateRange = null;
    if (rangeComparator === void 0)
      rangeComparator = null;
    LinearScale.call(this, interpolateRange, uninterpolateRange, rangeComparator);
    this.exponent_dma9hv$_0 = exponent;
  }
  Object.defineProperty(PowerScale.prototype, 'exponent', {
    configurable: true,
    get: function () {
      return this.exponent_dma9hv$_0;
    },
    set: function (value) {
      this.exponent_dma9hv$_0 = value;
      this.rescale();
    }
  });
  PowerScale.prototype.copy = function () {
    var $receiver = new PowerScale(this.exponent, this.interpolateRange, this.uninterpolateRange, this.rangeComparator);
    $receiver.domain = this.domain;
    $receiver.range = this.range;
    $receiver.clamp = this.clamp;
    return $receiver;
  };
  function PowerScale$uninterpolateDomain$lambda(f) {
    return get_pct(0);
  }
  function PowerScale$uninterpolateDomain$lambda_0(this$PowerScale, closure$dFrom, closure$dTo) {
    return function (t) {
      return new Percent((this$PowerScale.raise_0(t, this$PowerScale.exponent) - closure$dFrom) / closure$dTo);
    };
  }
  PowerScale.prototype.uninterpolateDomain_xwzc9q$ = function (from, to) {
    var dFrom = this.raise_0(from, this.exponent);
    var dTo = this.raise_0(to, this.exponent) - dFrom;
    return dTo === 0.0 || isNaN_0(dTo) ? PowerScale$uninterpolateDomain$lambda : PowerScale$uninterpolateDomain$lambda_0(this, dFrom, dTo);
  };
  function PowerScale$interpolateDomain$lambda(closure$ra, closure$rb, this$PowerScale) {
    return function (t) {
      return this$PowerScale.raise_0(closure$ra + closure$rb * t.value, 1.0 / this$PowerScale.exponent);
    };
  }
  PowerScale.prototype.interpolateDomain_xwzc9q$ = function (from, to) {
    var ra = this.raise_0(from, this.exponent);
    var rb = this.raise_0(to, this.exponent) - ra;
    return PowerScale$interpolateDomain$lambda(ra, rb, this);
  };
  PowerScale.prototype.raise_0 = function (x, exponent) {
    var pow = JsMath.pow(x, exponent);
    return x < 0.0 ? -pow : pow;
  };
  PowerScale.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'PowerScale',
    interfaces: [LinearScale]
  };
  function QuantileScale() {
    this.thresholds_0 = ArrayList_init();
    this.domain_tcu4ug$_0 = emptyList();
    this.range_7d1n4b$_0 = emptyList();
  }
  Object.defineProperty(QuantileScale.prototype, 'quantiles', {
    configurable: true,
    get: function () {
      return toList(this.thresholds_0);
    }
  });
  Object.defineProperty(QuantileScale.prototype, 'domain', {
    configurable: true,
    get: function () {
      return toList(this.domain_tcu4ug$_0);
    },
    set: function (value) {
      var destination = ArrayList_init();
      var tmp$;
      tmp$ = value.iterator();
      while (tmp$.hasNext()) {
        var element = tmp$.next();
        if (!isNaN_0(element))
          destination.add_11rb$(element);
      }
      var filteredValue = sorted(destination);
      if (!!filteredValue.isEmpty()) {
        var message = "Domain can't be empty.";
        throw IllegalArgumentException_init(message.toString());
      }this.domain_tcu4ug$_0 = filteredValue;
      this.rescale_0();
    }
  });
  Object.defineProperty(QuantileScale.prototype, 'range', {
    configurable: true,
    get: function () {
      return toList(this.range_7d1n4b$_0);
    },
    set: function (value) {
      if (!!value.isEmpty()) {
        var message = "Range can't be empty.";
        throw IllegalArgumentException_init(message.toString());
      }this.range_7d1n4b$_0 = toList(value);
      this.rescale_0();
    }
  });
  QuantileScale.prototype.rescale_0 = function () {
    if (this.domain.isEmpty() || this.range.isEmpty())
      return;
    var i = 0;
    var b = this.range.size;
    var n = JsMath.max(1, b);
    this.thresholds_0 = ArrayList_init();
    while ((i = i + 1 | 0, i) < n) {
      this.thresholds_0.add_wxm5ur$(i - 1 | 0, quantile(this.domain, i / n));
    }
  };
  QuantileScale.prototype.invertExtent_11rb$ = function (rangeValue) {
    var tmp$;
    if (!!this.domain.isEmpty()) {
      var message = "Can't compute a Quantile Scale with an empty Domain";
      throw IllegalStateException_init_0(message.toString());
    }if (!!this.range.isEmpty()) {
      var message_0 = "Can't compute a Quantile Scale with an empty Range";
      throw IllegalStateException_init_0(message_0.toString());
    }var index = this.range.indexOf_11rb$(rangeValue);
    if (index === -1)
      tmp$ = listOf([kotlin_js_internal_DoubleCompanionObject.NaN, kotlin_js_internal_DoubleCompanionObject.NaN]);
    else
      tmp$ = listOf([index > 0 ? this.thresholds_0.get_za3lpa$(index - 1 | 0) : first(this.domain), index < this.thresholds_0.size ? this.thresholds_0.get_za3lpa$(index) : last(this.domain)]);
    return tmp$;
  };
  QuantileScale.prototype.invoke_11rb$ = function (domainValue) {
    if (!!isNaN_0(domainValue)) {
      var message = "domainValue can't be NaN";
      throw IllegalArgumentException_init(message.toString());
    }if (!!this.domain.isEmpty()) {
      var message_0 = "Can't compute a Quantile Scale with an empty Domain";
      throw IllegalStateException_init_0(message_0.toString());
    }if (!!this.range.isEmpty()) {
      var message_1 = "Can't compute a Quantile Scale with an empty Range";
      throw IllegalStateException_init_0(message_1.toString());
    }return this.range.get_za3lpa$(bisectRight(this.thresholds_0, domainValue, naturalOrder()));
  };
  QuantileScale.prototype.copy = function () {
    var $receiver = new QuantileScale();
    $receiver.domain = this.domain;
    $receiver.range = this.range;
    $receiver.rescale_0();
    return $receiver;
  };
  QuantileScale.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'QuantileScale',
    interfaces: [DiscreteRange, DiscreteDomain, Scale]
  };
  function quantile$lambda(x, f, f_0) {
    return x;
  }
  function quantile(values, p, f) {
    if (f === void 0)
      f = quantile$lambda;
    if (!!values.isEmpty()) {
      var message = 'Values must not be empty.';
      throw IllegalArgumentException_init(message.toString());
    }var size = values.size;
    if (p <= 0.0 || size < 2)
      return f(values.get_za3lpa$(0), size - 1 - 1 | 0, values);
    var h = (size - 1 | 0) * p;
    var i = numberToInt(JsMath.floor(h));
    var a = f(values.get_za3lpa$(i), i, values);
    var b = f(values.get_za3lpa$(i + 1 | 0), i + 1 | 0, values);
    return a + (b - a) * (h - i);
  }
  function QuantizeScale() {
    this.quantizedDomain_0 = mutableListOf([0.5]);
    this.range_wdbhml$_0 = emptyList();
    this.domain_n92suu$_0 = intervalOf(0.0, 1.0);
  }
  Object.defineProperty(QuantizeScale.prototype, 'range', {
    configurable: true,
    get: function () {
      return toList(this.range_wdbhml$_0);
    },
    set: function (value) {
      this.range_wdbhml$_0 = toList(value);
      this.rescale_0();
    }
  });
  Object.defineProperty(QuantizeScale.prototype, 'domain', {
    configurable: true,
    get: function () {
      return this.domain_n92suu$_0;
    },
    set: function (value) {
      this.domain_n92suu$_0 = value;
      this.rescale_0();
    }
  });
  QuantizeScale.prototype.rescale_0 = function () {
    this.quantizedDomain_0.clear();
    var size = this.range.size - 1 | 0;
    for (var index = 0; index < size; index++) {
      var element = ((index + 1 | 0) * this.domain.end - (index - size | 0) * this.domain.start) / (size + 1 | 0);
      this.quantizedDomain_0.add_11rb$(element);
    }
  };
  QuantizeScale.prototype.invoke_11rb$ = function (domainValue) {
    return this.range.get_za3lpa$(bisectRight(this.quantizedDomain_0, domainValue, naturalOrder(), 0, this.range.size - 1 | 0));
  };
  QuantizeScale.prototype.invertExtent_11rb$ = function (rangeValue) {
    var tmp$;
    var i = this.range.indexOf_11rb$(rangeValue);
    var size = this.range.size - 1 | 0;
    if (i < 0)
      tmp$ = listOf([kotlin_js_internal_DoubleCompanionObject.NaN, kotlin_js_internal_DoubleCompanionObject.NaN]);
    else if (i < 1)
      tmp$ = listOf([this.domain.start, first(this.quantizedDomain_0)]);
    else if (i >= size)
      tmp$ = listOf([this.quantizedDomain_0.get_za3lpa$(size - 1 | 0), this.domain.end]);
    else
      tmp$ = listOf([this.quantizedDomain_0.get_za3lpa$(i - 1 | 0), this.quantizedDomain_0.get_za3lpa$(i)]);
    return tmp$;
  };
  QuantizeScale.prototype.copy = function () {
    var $receiver = new QuantizeScale();
    $receiver.domain = this.domain;
    $receiver.range = this.range;
    $receiver.rescale_0();
    return $receiver;
  };
  QuantizeScale.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'QuantizeScale',
    interfaces: [DiscreteRange, StrictlyContinuousDomain, Scale]
  };
  function Scale() {
  }
  Scale.$metadata$ = {
    kind: Kind_INTERFACE,
    simpleName: 'Scale',
    interfaces: []
  };
  function ContinuousDomain() {
  }
  ContinuousDomain.$metadata$ = {
    kind: Kind_INTERFACE,
    simpleName: 'ContinuousDomain',
    interfaces: []
  };
  function DiscreteDomain() {
  }
  DiscreteDomain.$metadata$ = {
    kind: Kind_INTERFACE,
    simpleName: 'DiscreteDomain',
    interfaces: []
  };
  function StrictlyContinuousDomain() {
  }
  StrictlyContinuousDomain.$metadata$ = {
    kind: Kind_INTERFACE,
    simpleName: 'StrictlyContinuousDomain',
    interfaces: []
  };
  function ContinuousRangeScale() {
  }
  ContinuousRangeScale.prototype.start = function () {
    return first(this.range);
  };
  ContinuousRangeScale.prototype.end = function () {
    return last(this.range);
  };
  ContinuousRangeScale.$metadata$ = {
    kind: Kind_INTERFACE,
    simpleName: 'ContinuousRangeScale',
    interfaces: [FirstLastRange, Scale]
  };
  function DiscreteRange() {
  }
  DiscreteRange.$metadata$ = {
    kind: Kind_INTERFACE,
    simpleName: 'DiscreteRange',
    interfaces: []
  };
  function StrictlyContinuousRange() {
  }
  StrictlyContinuousRange.prototype.start = function () {
    return this.range.start;
  };
  StrictlyContinuousRange.prototype.end = function () {
    return this.range.end;
  };
  StrictlyContinuousRange.$metadata$ = {
    kind: Kind_INTERFACE,
    simpleName: 'StrictlyContinuousRange',
    interfaces: [FirstLastRange]
  };
  function FirstLastRange() {
  }
  FirstLastRange.$metadata$ = {
    kind: Kind_INTERFACE,
    simpleName: 'FirstLastRange',
    interfaces: [Scale]
  };
  function StrictlyContinuous(start, end) {
    this.start = start;
    this.end = end;
  }
  StrictlyContinuous.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'StrictlyContinuous',
    interfaces: []
  };
  StrictlyContinuous.prototype.component1 = function () {
    return this.start;
  };
  StrictlyContinuous.prototype.component2 = function () {
    return this.end;
  };
  StrictlyContinuous.prototype.copy_xwzc9q$ = function (start, end) {
    return new StrictlyContinuous(start === void 0 ? this.start : start, end === void 0 ? this.end : end);
  };
  StrictlyContinuous.prototype.toString = function () {
    return 'StrictlyContinuous(start=' + Kotlin.toString(this.start) + (', end=' + Kotlin.toString(this.end)) + ')';
  };
  StrictlyContinuous.prototype.hashCode = function () {
    var result = 0;
    result = result * 31 + Kotlin.hashCode(this.start) | 0;
    result = result * 31 + Kotlin.hashCode(this.end) | 0;
    return result;
  };
  StrictlyContinuous.prototype.equals = function (other) {
    return this === other || (other !== null && (typeof other === 'object' && (Object.getPrototypeOf(this) === Object.getPrototypeOf(other) && (Kotlin.equals(this.start, other.start) && Kotlin.equals(this.end, other.end)))));
  };
  function intervalOf(start, end) {
    return new StrictlyContinuous(start, end);
  }
  function intervalOf_0(values) {
    return new StrictlyContinuous(first_0(values), last_0(values));
  }
  function ClampableScale() {
  }
  ClampableScale.$metadata$ = {
    kind: Kind_INTERFACE,
    simpleName: 'ClampableScale',
    interfaces: []
  };
  function NiceableScale() {
  }
  NiceableScale.prototype.nice_za3lpa$ = function (count, callback$default) {
    if (count === void 0)
      count = 10;
    callback$default ? callback$default(count) : this.nice_za3lpa$$default(count);
  };
  NiceableScale.$metadata$ = {
    kind: Kind_INTERFACE,
    simpleName: 'NiceableScale',
    interfaces: [ContinuousDomain]
  };
  function InvertableScale() {
  }
  InvertableScale.$metadata$ = {
    kind: Kind_INTERFACE,
    simpleName: 'InvertableScale',
    interfaces: [Scale]
  };
  function Tickable() {
  }
  Tickable.prototype.ticks_za3lpa$ = function (count, callback$default) {
    if (count === void 0)
      count = 10;
    return callback$default ? callback$default(count) : this.ticks_za3lpa$$default(count);
  };
  Tickable.$metadata$ = {
    kind: Kind_INTERFACE,
    simpleName: 'Tickable',
    interfaces: []
  };
  function Scales() {
    Scales_instance = this;
  }
  function Scales$Continuous() {
    Scales$Continuous_instance = this;
  }
  Scales$Continuous.prototype.identity = function () {
    var $receiver = new LinearScale(getCallableRef('interpolateNumber', function (p1, p2) {
      return interpolateNumber(p1, p2);
    }), getCallableRef('uninterpolateNumber', function (p1, p2) {
      return uninterpolateNumber(p1, p2);
    }), naturalOrder());
    $receiver.domain = listOf([0.0, 1.0]);
    $receiver.range = listOf([0.0, 1.0]);
    return $receiver;
  };
  function Scales$Continuous$linear$lambda($receiver) {
    return Unit;
  }
  Scales$Continuous.prototype.linear_hv2kdx$ = function (init) {
    if (init === void 0)
      init = Scales$Continuous$linear$lambda;
    var $receiver = new LinearScale(getCallableRef('interpolateNumber', function (p1, p2) {
      return interpolateNumber(p1, p2);
    }), getCallableRef('uninterpolateNumber', function (p1, p2) {
      return uninterpolateNumber(p1, p2);
    }), naturalOrder());
    init($receiver);
    return $receiver;
  };
  function Scales$Continuous$linearRound$lambda($receiver) {
    return Unit;
  }
  Scales$Continuous.prototype.linearRound_hv2kdx$ = function (init) {
    if (init === void 0)
      init = Scales$Continuous$linearRound$lambda;
    var $receiver = new LinearScale(getCallableRef('interpolateRound', function (p1, p2) {
      return interpolateRound(p1, p2);
    }), getCallableRef('uninterpolateNumber', function (p1, p2) {
      return uninterpolateNumber(p1, p2);
    }), naturalOrder());
    init($receiver);
    return $receiver;
  };
  function Scales$Continuous$log$lambda($receiver) {
    return Unit;
  }
  Scales$Continuous.prototype.log_19xkcx$ = function (base, init) {
    if (base === void 0)
      base = 10.0;
    if (init === void 0)
      init = Scales$Continuous$log$lambda;
    var $receiver = new LogScale(base, getCallableRef('interpolateNumber', function (p1, p2) {
      return interpolateNumber(p1, p2);
    }), getCallableRef('uninterpolateNumber', function (p1, p2) {
      return uninterpolateNumber(p1, p2);
    }), naturalOrder());
    init($receiver);
    return $receiver;
  };
  Scales$Continuous.prototype.logRound_14dthe$ = function (base) {
    if (base === void 0)
      base = 10.0;
    return new LogScale(base, getCallableRef('interpolateRound', function (p1, p2) {
      return interpolateRound(p1, p2);
    }), getCallableRef('uninterpolateNumber', function (p1, p2) {
      return uninterpolateNumber(p1, p2);
    }), naturalOrder());
  };
  function Scales$Continuous$vector$lambda($receiver) {
    return Unit;
  }
  Scales$Continuous.prototype.vector_4k8xie$ = function (init) {
    if (init === void 0)
      init = Scales$Continuous$vector$lambda;
    var $receiver = new LinearScale(getCallableRef('interpolatePoint', function (p1, p2) {
      return interpolatePoint(p1, p2);
    }), getCallableRef('uninterpolatePointOnX', function (p1, p2) {
      return uninterpolatePointOnX(p1, p2);
    }), new PointComparatorX());
    init($receiver);
    return $receiver;
  };
  function Scales$Continuous$pow$lambda($receiver) {
    return Unit;
  }
  Scales$Continuous.prototype.pow_t2h1zn$ = function (exponent, init) {
    if (exponent === void 0)
      exponent = 1.0;
    if (init === void 0)
      init = Scales$Continuous$pow$lambda;
    var $receiver = new PowerScale(exponent, getCallableRef('interpolateNumber', function (p1, p2) {
      return interpolateNumber(p1, p2);
    }), getCallableRef('uninterpolateNumber', function (p1, p2) {
      return uninterpolateNumber(p1, p2);
    }), naturalOrder());
    init($receiver);
    return $receiver;
  };
  function Scales$Continuous$powRound$lambda($receiver) {
    return Unit;
  }
  Scales$Continuous.prototype.powRound_t2h1zn$ = function (exponent, init) {
    if (exponent === void 0)
      exponent = 1.0;
    if (init === void 0)
      init = Scales$Continuous$powRound$lambda;
    var $receiver = new PowerScale(exponent, getCallableRef('interpolateRound', function (p1, p2) {
      return interpolateRound(p1, p2);
    }), getCallableRef('uninterpolateNumber', function (p1, p2) {
      return uninterpolateNumber(p1, p2);
    }), naturalOrder());
    init($receiver);
    return $receiver;
  };
  function Scales$Continuous$sqrt$lambda($receiver) {
    return Unit;
  }
  Scales$Continuous.prototype.sqrt_y19wbf$ = function (init) {
    if (init === void 0)
      init = Scales$Continuous$sqrt$lambda;
    var $receiver = new PowerScale(0.5, getCallableRef('interpolateNumber', function (p1, p2) {
      return interpolateNumber(p1, p2);
    }), getCallableRef('uninterpolateNumber', function (p1, p2) {
      return uninterpolateNumber(p1, p2);
    }), naturalOrder());
    init($receiver);
    return $receiver;
  };
  function Scales$Continuous$sqrtRound$lambda($receiver) {
    return Unit;
  }
  Scales$Continuous.prototype.sqrtRound_y19wbf$ = function (init) {
    if (init === void 0)
      init = Scales$Continuous$sqrtRound$lambda;
    var $receiver = new PowerScale(0.5, getCallableRef('interpolateRound', function (p1, p2) {
      return interpolateRound(p1, p2);
    }), getCallableRef('uninterpolateNumber', function (p1, p2) {
      return uninterpolateNumber(p1, p2);
    }), naturalOrder());
    init($receiver);
    return $receiver;
  };
  function Scales$Continuous$time$lambda($receiver) {
    return Unit;
  }
  Scales$Continuous.prototype.time_5n7183$ = function (init) {
    if (init === void 0)
      init = Scales$Continuous$time$lambda;
    var $receiver = new TimeScale(getCallableRef('interpolateNumber', function (p1, p2) {
      return interpolateNumber(p1, p2);
    }), getCallableRef('uninterpolateNumber', function (p1, p2) {
      return uninterpolateNumber(p1, p2);
    }), naturalOrder());
    init($receiver);
    return $receiver;
  };
  Scales$Continuous.prototype.sequential_745qxq$ = function (interpolator) {
    return new SequentialScale(interpolator);
  };
  Scales$Continuous.prototype.sequential_djng8h$ = function (interpolator) {
    return new SequentialScale(interpolator);
  };
  Scales$Continuous.$metadata$ = {
    kind: Kind_OBJECT,
    simpleName: 'Continuous',
    interfaces: []
  };
  var Scales$Continuous_instance = null;
  function Scales$Continuous_getInstance() {
    if (Scales$Continuous_instance === null) {
      new Scales$Continuous();
    }return Scales$Continuous_instance;
  }
  function Scales$Quantized() {
    Scales$Quantized_instance = this;
  }
  function Scales$Quantized$quantile$lambda($receiver) {
    return Unit;
  }
  Scales$Quantized.prototype.quantile_v47b15$ = function (init) {
    if (init === void 0)
      init = Scales$Quantized$quantile$lambda;
    var $receiver = new QuantileScale();
    init($receiver);
    return $receiver;
  };
  function Scales$Quantized$quantize$lambda($receiver) {
    return Unit;
  }
  Scales$Quantized.prototype.quantize_shvox3$ = function (init) {
    if (init === void 0)
      init = Scales$Quantized$quantize$lambda;
    var $receiver = new QuantizeScale();
    init($receiver);
    return $receiver;
  };
  function Scales$Quantized$threshold$lambda($receiver) {
    return Unit;
  }
  Scales$Quantized.prototype.threshold_9bd9ml$ = function (init) {
    if (init === void 0)
      init = Scales$Quantized$threshold$lambda;
    var $receiver = new ThresholdScale();
    init($receiver);
    return $receiver;
  };
  Scales$Quantized.$metadata$ = {
    kind: Kind_OBJECT,
    simpleName: 'Quantized',
    interfaces: []
  };
  var Scales$Quantized_instance = null;
  function Scales$Quantized_getInstance() {
    if (Scales$Quantized_instance === null) {
      new Scales$Quantized();
    }return Scales$Quantized_instance;
  }
  function Scales$Discrete() {
    Scales$Discrete_instance = this;
  }
  function Scales$Discrete$point$lambda($receiver) {
    return Unit;
  }
  Scales$Discrete.prototype.point_dq500o$ = function (init) {
    if (init === void 0)
      init = Scales$Discrete$point$lambda;
    var $receiver = new PointScale();
    init($receiver);
    return $receiver;
  };
  function Scales$Discrete$band$lambda($receiver) {
    return Unit;
  }
  Scales$Discrete.prototype.band_2gqbrx$ = function (init) {
    if (init === void 0)
      init = Scales$Discrete$band$lambda;
    var $receiver = new BandScale();
    init($receiver);
    return $receiver;
  };
  function Scales$Discrete$ordinal$lambda($receiver) {
    return Unit;
  }
  Scales$Discrete.prototype.ordinal_2idftj$ = function (init) {
    if (init === void 0)
      init = Scales$Discrete$ordinal$lambda;
    var $receiver = new OrdinalScale();
    init($receiver);
    return $receiver;
  };
  Scales$Discrete.$metadata$ = {
    kind: Kind_OBJECT,
    simpleName: 'Discrete',
    interfaces: []
  };
  var Scales$Discrete_instance = null;
  function Scales$Discrete_getInstance() {
    if (Scales$Discrete_instance === null) {
      new Scales$Discrete();
    }return Scales$Discrete_instance;
  }
  Scales.$metadata$ = {
    kind: Kind_OBJECT,
    simpleName: 'Scales',
    interfaces: []
  };
  var Scales_instance = null;
  function Scales_getInstance() {
    if (Scales_instance === null) {
      new Scales();
    }return Scales_instance;
  }
  function ScalesChromatic() {
    ScalesChromatic_instance = this;
  }
  function ScalesChromatic$Continuous() {
    ScalesChromatic$Continuous_instance = this;
  }
  function ScalesChromatic$Continuous$linearRGB$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Continuous.prototype.linearRGB_qkuwoo$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Continuous$linearRGB$lambda;
    var $receiver = new LinearScale(getCallableRef('rgbLinearInterpolator', function (p1, p2) {
      return rgbLinearInterpolator(p1, p2);
    }));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Continuous$defaultRGB$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Continuous.prototype.defaultRGB_qkuwoo$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Continuous$defaultRGB$lambda;
    var $receiver = new LinearScale(getCallableRef('rgbDefaultInterpolator', function (p1, p2) {
      return rgbDefaultInterpolator(p1, p2);
    }));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Continuous$linearLAB$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Continuous.prototype.linearLAB_qkuwoo$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Continuous$linearLAB$lambda;
    var $receiver = new LinearScale(getCallableRef('labInterpolator', function (p1, p2) {
      return labInterpolator(p1, p2);
    }));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Continuous$linearHCL$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Continuous.prototype.linearHCL_qkuwoo$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Continuous$linearHCL$lambda;
    var $receiver = new LinearScale(getCallableRef('hclInterpolator', function (p1, p2) {
      return hclInterpolator(p1, p2);
    }));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Continuous$linearHCLLong$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Continuous.prototype.linearHCLLong_qkuwoo$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Continuous$linearHCLLong$lambda;
    var $receiver = new LinearScale(getCallableRef('hclLongInterpolator', function (p1, p2) {
      return hclLongInterpolator(p1, p2);
    }));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Continuous$linearHSL$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Continuous.prototype.linearHSL_qkuwoo$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Continuous$linearHSL$lambda;
    var $receiver = new LinearScale(getCallableRef('hslInterpolator', function (p1, p2) {
      return hslInterpolator(p1, p2);
    }));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Continuous$linearHSLLong$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Continuous.prototype.linearHSLLong_qkuwoo$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Continuous$linearHSLLong$lambda;
    var $receiver = new LinearScale(getCallableRef('hslLongInterpolator', function (p1, p2) {
      return hslLongInterpolator(p1, p2);
    }));
    init($receiver);
    return $receiver;
  };
  ScalesChromatic$Continuous.$metadata$ = {
    kind: Kind_OBJECT,
    simpleName: 'Continuous',
    interfaces: []
  };
  var ScalesChromatic$Continuous_instance = null;
  function ScalesChromatic$Continuous_getInstance() {
    if (ScalesChromatic$Continuous_instance === null) {
      new ScalesChromatic$Continuous();
    }return ScalesChromatic$Continuous_instance;
  }
  function ScalesChromatic$Sequential() {
    ScalesChromatic$Sequential_instance = this;
  }
  function ScalesChromatic$Sequential$SingleHue() {
    ScalesChromatic$Sequential$SingleHue_instance = this;
  }
  function ScalesChromatic$Sequential$SingleHue$blues$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Sequential$SingleHue.prototype.blues_bhymni$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Sequential$SingleHue$blues$lambda;
    var $receiver = new SequentialScale(rgbBasisInterpolator(EncodedColors.Companion.blues9.colors));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Sequential$SingleHue$greens$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Sequential$SingleHue.prototype.greens_bhymni$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Sequential$SingleHue$greens$lambda;
    var $receiver = new SequentialScale(rgbBasisInterpolator(EncodedColors.Companion.greens9.colors));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Sequential$SingleHue$greys$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Sequential$SingleHue.prototype.greys_bhymni$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Sequential$SingleHue$greys$lambda;
    var $receiver = new SequentialScale(rgbBasisInterpolator(EncodedColors.Companion.greys9.colors));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Sequential$SingleHue$oranges$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Sequential$SingleHue.prototype.oranges_bhymni$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Sequential$SingleHue$oranges$lambda;
    var $receiver = new SequentialScale(rgbBasisInterpolator(EncodedColors.Companion.oranges9.colors));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Sequential$SingleHue$purples$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Sequential$SingleHue.prototype.purples_bhymni$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Sequential$SingleHue$purples$lambda;
    var $receiver = new SequentialScale(rgbBasisInterpolator(EncodedColors.Companion.purples9.colors));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Sequential$SingleHue$reds$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Sequential$SingleHue.prototype.reds_bhymni$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Sequential$SingleHue$reds$lambda;
    var $receiver = new SequentialScale(rgbBasisInterpolator(EncodedColors.Companion.reds9.colors));
    init($receiver);
    return $receiver;
  };
  ScalesChromatic$Sequential$SingleHue.$metadata$ = {
    kind: Kind_OBJECT,
    simpleName: 'SingleHue',
    interfaces: []
  };
  var ScalesChromatic$Sequential$SingleHue_instance = null;
  function ScalesChromatic$Sequential$SingleHue_getInstance() {
    if (ScalesChromatic$Sequential$SingleHue_instance === null) {
      new ScalesChromatic$Sequential$SingleHue();
    }return ScalesChromatic$Sequential$SingleHue_instance;
  }
  function ScalesChromatic$Sequential$MultiHue() {
    ScalesChromatic$Sequential$MultiHue_instance = this;
  }
  function ScalesChromatic$Sequential$MultiHue$viridis$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Sequential$MultiHue.prototype.viridis_bhymni$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Sequential$MultiHue$viridis$lambda;
    var $receiver = new SequentialScale(rgbBasisInterpolator(EncodedColors.Companion.viridis.colors));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Sequential$MultiHue$magma$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Sequential$MultiHue.prototype.magma_bhymni$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Sequential$MultiHue$magma$lambda;
    var $receiver = new SequentialScale(rgbBasisInterpolator(EncodedColors.Companion.magma.colors));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Sequential$MultiHue$inferno$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Sequential$MultiHue.prototype.inferno_bhymni$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Sequential$MultiHue$inferno$lambda;
    var $receiver = new SequentialScale(rgbBasisInterpolator(EncodedColors.Companion.inferno.colors));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Sequential$MultiHue$plasma$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Sequential$MultiHue.prototype.plasma_bhymni$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Sequential$MultiHue$plasma$lambda;
    var $receiver = new SequentialScale(rgbBasisInterpolator(EncodedColors.Companion.plasma.colors));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Sequential$MultiHue$blue_green$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Sequential$MultiHue.prototype.blue_green_bhymni$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Sequential$MultiHue$blue_green$lambda;
    var $receiver = new SequentialScale(rgbBasisInterpolator(EncodedColors.Companion.BuGN9.colors));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Sequential$MultiHue$blue_purple$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Sequential$MultiHue.prototype.blue_purple_bhymni$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Sequential$MultiHue$blue_purple$lambda;
    var $receiver = new SequentialScale(rgbBasisInterpolator(EncodedColors.Companion.BuPu9.colors));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Sequential$MultiHue$green_blue$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Sequential$MultiHue.prototype.green_blue_bhymni$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Sequential$MultiHue$green_blue$lambda;
    var $receiver = new SequentialScale(rgbBasisInterpolator(EncodedColors.Companion.GnBu9.colors));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Sequential$MultiHue$orange_red$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Sequential$MultiHue.prototype.orange_red_bhymni$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Sequential$MultiHue$orange_red$lambda;
    var $receiver = new SequentialScale(rgbBasisInterpolator(EncodedColors.Companion.OrRd9.colors));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Sequential$MultiHue$purple_blue$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Sequential$MultiHue.prototype.purple_blue_bhymni$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Sequential$MultiHue$purple_blue$lambda;
    var $receiver = new SequentialScale(rgbBasisInterpolator(EncodedColors.Companion.PuBu9.colors));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Sequential$MultiHue$purple_blue_green$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Sequential$MultiHue.prototype.purple_blue_green_bhymni$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Sequential$MultiHue$purple_blue_green$lambda;
    var $receiver = new SequentialScale(rgbBasisInterpolator(EncodedColors.Companion.PuBuGn9.colors));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Sequential$MultiHue$purple_red$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Sequential$MultiHue.prototype.purple_red_bhymni$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Sequential$MultiHue$purple_red$lambda;
    var $receiver = new SequentialScale(rgbBasisInterpolator(EncodedColors.Companion.PuRd9.colors));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Sequential$MultiHue$red_purple$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Sequential$MultiHue.prototype.red_purple_bhymni$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Sequential$MultiHue$red_purple$lambda;
    var $receiver = new SequentialScale(rgbBasisInterpolator(EncodedColors.Companion.RdPu9.colors));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Sequential$MultiHue$yellow_green$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Sequential$MultiHue.prototype.yellow_green_bhymni$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Sequential$MultiHue$yellow_green$lambda;
    var $receiver = new SequentialScale(rgbBasisInterpolator(EncodedColors.Companion.YlGn9.colors));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Sequential$MultiHue$yellow_green_blue$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Sequential$MultiHue.prototype.yellow_green_blue_bhymni$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Sequential$MultiHue$yellow_green_blue$lambda;
    var $receiver = new SequentialScale(rgbBasisInterpolator(EncodedColors.Companion.YlGnbU9.colors));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Sequential$MultiHue$yellow_green_brown$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Sequential$MultiHue.prototype.yellow_green_brown_bhymni$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Sequential$MultiHue$yellow_green_brown$lambda;
    var $receiver = new SequentialScale(rgbBasisInterpolator(EncodedColors.Companion.YlGnBr9.colors));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Sequential$MultiHue$yellow_green_red$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Sequential$MultiHue.prototype.yellow_green_red_bhymni$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Sequential$MultiHue$yellow_green_red$lambda;
    var $receiver = new SequentialScale(rgbBasisInterpolator(EncodedColors.Companion.YlGnRd9.colors));
    init($receiver);
    return $receiver;
  };
  ScalesChromatic$Sequential$MultiHue.$metadata$ = {
    kind: Kind_OBJECT,
    simpleName: 'MultiHue',
    interfaces: []
  };
  var ScalesChromatic$Sequential$MultiHue_instance = null;
  function ScalesChromatic$Sequential$MultiHue_getInstance() {
    if (ScalesChromatic$Sequential$MultiHue_instance === null) {
      new ScalesChromatic$Sequential$MultiHue();
    }return ScalesChromatic$Sequential$MultiHue_instance;
  }
  function ScalesChromatic$Sequential$Diverging() {
    ScalesChromatic$Sequential$Diverging_instance = this;
  }
  function ScalesChromatic$Sequential$Diverging$brown_blueGreen$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Sequential$Diverging.prototype.brown_blueGreen_bhymni$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Sequential$Diverging$brown_blueGreen$lambda;
    var $receiver = new SequentialScale(rgbBasisInterpolator(EncodedColors.Companion.BrBG11.colors));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Sequential$Diverging$pink_green$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Sequential$Diverging.prototype.pink_green_bhymni$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Sequential$Diverging$pink_green$lambda;
    var $receiver = new SequentialScale(rgbBasisInterpolator(EncodedColors.Companion.PiYG11.colors));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Sequential$Diverging$purple_green$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Sequential$Diverging.prototype.purple_green_bhymni$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Sequential$Diverging$purple_green$lambda;
    var $receiver = new SequentialScale(rgbBasisInterpolator(EncodedColors.Companion.PRGn11.colors));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Sequential$Diverging$purple_orange$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Sequential$Diverging.prototype.purple_orange_bhymni$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Sequential$Diverging$purple_orange$lambda;
    var $receiver = new SequentialScale(rgbBasisInterpolator(EncodedColors.Companion.PuOR11.colors));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Sequential$Diverging$red_blue$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Sequential$Diverging.prototype.red_blue_bhymni$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Sequential$Diverging$red_blue$lambda;
    var $receiver = new SequentialScale(rgbBasisInterpolator(EncodedColors.Companion.RdBU11.colors));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Sequential$Diverging$red_grey$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Sequential$Diverging.prototype.red_grey_bhymni$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Sequential$Diverging$red_grey$lambda;
    var $receiver = new SequentialScale(rgbBasisInterpolator(EncodedColors.Companion.RdGY11.colors));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Sequential$Diverging$red_yellow_blue$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Sequential$Diverging.prototype.red_yellow_blue_bhymni$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Sequential$Diverging$red_yellow_blue$lambda;
    var $receiver = new SequentialScale(rgbBasisInterpolator(EncodedColors.Companion.RdYlBu11.colors));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Sequential$Diverging$blue_yellow_red$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Sequential$Diverging.prototype.blue_yellow_red_bhymni$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Sequential$Diverging$blue_yellow_red$lambda;
    var $receiver = new SequentialScale(rgbBasisInterpolator(EncodedColors.Companion.BuYlRd11.colors));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Sequential$Diverging$red_yellow_green$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Sequential$Diverging.prototype.red_yellow_green_bhymni$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Sequential$Diverging$red_yellow_green$lambda;
    var $receiver = new SequentialScale(rgbBasisInterpolator(EncodedColors.Companion.RdYlGn11.colors));
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Sequential$Diverging$spectral$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Sequential$Diverging.prototype.spectral_bhymni$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Sequential$Diverging$spectral$lambda;
    var $receiver = new SequentialScale(rgbBasisInterpolator(EncodedColors.Companion.spectral11.colors));
    init($receiver);
    return $receiver;
  };
  ScalesChromatic$Sequential$Diverging.$metadata$ = {
    kind: Kind_OBJECT,
    simpleName: 'Diverging',
    interfaces: []
  };
  var ScalesChromatic$Sequential$Diverging_instance = null;
  function ScalesChromatic$Sequential$Diverging_getInstance() {
    if (ScalesChromatic$Sequential$Diverging_instance === null) {
      new ScalesChromatic$Sequential$Diverging();
    }return ScalesChromatic$Sequential$Diverging_instance;
  }
  function ScalesChromatic$Sequential$Cyclical() {
    ScalesChromatic$Sequential$Cyclical_instance = this;
  }
  function ScalesChromatic$Sequential$Cyclical$sineBow$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Sequential$Cyclical.prototype.sineBow_bhymni$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Sequential$Cyclical$sineBow$lambda;
    var $receiver = new SequentialScale(rgbSineBowInterpolator());
    init($receiver);
    return $receiver;
  };
  ScalesChromatic$Sequential$Cyclical.$metadata$ = {
    kind: Kind_OBJECT,
    simpleName: 'Cyclical',
    interfaces: []
  };
  var ScalesChromatic$Sequential$Cyclical_instance = null;
  function ScalesChromatic$Sequential$Cyclical_getInstance() {
    if (ScalesChromatic$Sequential$Cyclical_instance === null) {
      new ScalesChromatic$Sequential$Cyclical();
    }return ScalesChromatic$Sequential$Cyclical_instance;
  }
  ScalesChromatic$Sequential.$metadata$ = {
    kind: Kind_OBJECT,
    simpleName: 'Sequential',
    interfaces: []
  };
  var ScalesChromatic$Sequential_instance = null;
  function ScalesChromatic$Sequential_getInstance() {
    if (ScalesChromatic$Sequential_instance === null) {
      new ScalesChromatic$Sequential();
    }return ScalesChromatic$Sequential_instance;
  }
  function ScalesChromatic$Discrete() {
    ScalesChromatic$Discrete_instance = this;
  }
  function ScalesChromatic$Discrete$accent8$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Discrete.prototype.accent8_kmhvxg$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Discrete$accent8$lambda;
    var $receiver = new OrdinalScale(EncodedColors.Companion.accents.colors);
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Discrete$dark8$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Discrete.prototype.dark8_kmhvxg$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Discrete$dark8$lambda;
    var $receiver = new OrdinalScale(EncodedColors.Companion.dark2.colors);
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Discrete$paired12$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Discrete.prototype.paired12_kmhvxg$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Discrete$paired12$lambda;
    var $receiver = new OrdinalScale(EncodedColors.Companion.paired.colors);
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Discrete$pastel9$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Discrete.prototype.pastel9_kmhvxg$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Discrete$pastel9$lambda;
    var $receiver = new OrdinalScale(EncodedColors.Companion.pastel1.colors);
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Discrete$pastel8$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Discrete.prototype.pastel8_kmhvxg$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Discrete$pastel8$lambda;
    var $receiver = new OrdinalScale(EncodedColors.Companion.pastel2.colors);
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Discrete$vivid9$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Discrete.prototype.vivid9_kmhvxg$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Discrete$vivid9$lambda;
    var $receiver = new OrdinalScale(EncodedColors.Companion.set1.colors);
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Discrete$vivid8$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Discrete.prototype.vivid8_kmhvxg$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Discrete$vivid8$lambda;
    var $receiver = new OrdinalScale(EncodedColors.Companion.set2.colors);
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Discrete$pale12$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Discrete.prototype.pale12_kmhvxg$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Discrete$pale12$lambda;
    var $receiver = new OrdinalScale(EncodedColors.Companion.set3.colors);
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Discrete$category10$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Discrete.prototype.category10_kmhvxg$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Discrete$category10$lambda;
    var $receiver = new OrdinalScale(EncodedColors.Companion.category10.colors);
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Discrete$categoryA20$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Discrete.prototype.categoryA20_kmhvxg$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Discrete$categoryA20$lambda;
    var $receiver = new OrdinalScale(EncodedColors.Companion.category20.colors);
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Discrete$categoryB20$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Discrete.prototype.categoryB20_kmhvxg$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Discrete$categoryB20$lambda;
    var $receiver = new OrdinalScale(EncodedColors.Companion.category20b.colors);
    init($receiver);
    return $receiver;
  };
  function ScalesChromatic$Discrete$categoryC20$lambda($receiver) {
    return Unit;
  }
  ScalesChromatic$Discrete.prototype.categoryC20_kmhvxg$ = function (init) {
    if (init === void 0)
      init = ScalesChromatic$Discrete$categoryC20$lambda;
    var $receiver = new OrdinalScale(EncodedColors.Companion.category20c.colors);
    init($receiver);
    return $receiver;
  };
  ScalesChromatic$Discrete.$metadata$ = {
    kind: Kind_OBJECT,
    simpleName: 'Discrete',
    interfaces: []
  };
  var ScalesChromatic$Discrete_instance = null;
  function ScalesChromatic$Discrete_getInstance() {
    if (ScalesChromatic$Discrete_instance === null) {
      new ScalesChromatic$Discrete();
    }return ScalesChromatic$Discrete_instance;
  }
  ScalesChromatic.$metadata$ = {
    kind: Kind_OBJECT,
    simpleName: 'ScalesChromatic',
    interfaces: []
  };
  var ScalesChromatic_instance = null;
  function ScalesChromatic_getInstance() {
    if (ScalesChromatic_instance === null) {
      new ScalesChromatic();
    }return ScalesChromatic_instance;
  }
  function SequentialScale(interpolator) {
    this.interpolator = interpolator;
    this.domain_8ag30o$_0 = intervalOf(0.0, 1.0);
    this.clamp_gaoomr$_0 = false;
  }
  Object.defineProperty(SequentialScale.prototype, 'domain', {
    configurable: true,
    get: function () {
      return this.domain_8ag30o$_0;
    },
    set: function (domain) {
      this.domain_8ag30o$_0 = domain;
    }
  });
  Object.defineProperty(SequentialScale.prototype, 'clamp', {
    configurable: true,
    get: function () {
      return this.clamp_gaoomr$_0;
    },
    set: function (clamp) {
      this.clamp_gaoomr$_0 = clamp;
    }
  });
  SequentialScale.prototype.invoke_za3lpa$ = function (domainValue) {
    return this.invoke_14dthe$(domainValue);
  };
  SequentialScale.prototype.invoke_14dthe$ = function (domainValue) {
    var uninterpolatedDomain = uninterpolateNumber(this.domain.start, this.domain.end)(domainValue);
    if (this.clamp)
      uninterpolatedDomain = uninterpolatedDomain.coerceToDefault();
    return this.interpolator(uninterpolatedDomain);
  };
  SequentialScale.prototype.ticks_za3lpa$$default = function (count) {
    return ticks(this.domain.start, this.domain.end, count);
  };
  SequentialScale.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'SequentialScale',
    interfaces: [StrictlyContinuousDomain, ClampableScale, Tickable]
  };
  function ThresholdScale() {
    this._domain = listOf_0(0.5);
    this._range = emptyList();
  }
  Object.defineProperty(ThresholdScale.prototype, 'range', {
    configurable: true,
    get: function () {
      return toList(this._range);
    },
    set: function (value) {
      this._range = toList(value);
    }
  });
  Object.defineProperty(ThresholdScale.prototype, 'domain', {
    configurable: true,
    get: function () {
      return toList(this._domain);
    },
    set: function (value) {
      if (!equals(sorted(value), value)) {
        var message = 'The domain must be sorted in ascending order.';
        throw IllegalArgumentException_init(message.toString());
      }this._domain = toList(value);
    }
  });
  ThresholdScale.prototype.invoke_za3lpa$ = function (domainValue) {
    return this.invoke_11rb$(domainValue);
  };
  ThresholdScale.prototype.invoke_11rb$ = function (domainValue) {
    if (!(this._range.size === (this._domain.size + 1 | 0))) {
      var message = 'The range size (actual: ' + this._range.size + ') must be 1 more than the domain size (actual: ' + this._domain.size + ').';
      throw IllegalStateException_init_0(message.toString());
    }return this._range.get_za3lpa$(bisectRight(this._domain, domainValue, naturalOrder(), 0, this._domain.size));
  };
  ThresholdScale.prototype.invertExtent_11rb$ = function (rangeValue) {
    var tmp$;
    if (!(this._range.size === (this._domain.size + 1 | 0))) {
      var message = 'The range size (actual: ' + this._range.size + ') must be 1 more than the domain size (actual: ' + this._domain.size + ').';
      throw IllegalStateException_init_0(message.toString());
    }var i = this._range.indexOf_11rb$(rangeValue);
    var size = this._range.size - 1 | 0;
    if (i < 0 || i > size)
      tmp$ = listOf([kotlin_js_internal_DoubleCompanionObject.NaN, kotlin_js_internal_DoubleCompanionObject.NaN]);
    else if (i === 0)
      tmp$ = listOf([kotlin_js_internal_DoubleCompanionObject.NaN, first(this._domain)]);
    else if (i === size)
      tmp$ = listOf([last(this.domain), kotlin_js_internal_DoubleCompanionObject.NaN]);
    else
      tmp$ = listOf([this._domain.get_za3lpa$(i - 1 | 0), this._domain.get_za3lpa$(i)]);
    return tmp$;
  };
  ThresholdScale.prototype.copy = function () {
    var $receiver = new ThresholdScale();
    $receiver.domain = this.domain;
    $receiver.range = this.range;
    return $receiver;
  };
  ThresholdScale.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'ThresholdScale',
    interfaces: [DiscreteDomain, DiscreteRange, Scale]
  };
  function dateComparator$lambda(a, b) {
    return a.compareTo_11rb$(b);
  }
  var dateComparator;
  function TickInterval(interval, step, duration) {
    this.interval = interval;
    this.step = step;
    this.duration = duration;
  }
  TickInterval.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'TickInterval',
    interfaces: []
  };
  TickInterval.prototype.component1 = function () {
    return this.interval;
  };
  TickInterval.prototype.component2 = function () {
    return this.step;
  };
  TickInterval.prototype.component3 = function () {
    return this.duration;
  };
  TickInterval.prototype.copy_hkrdj9$ = function (interval, step, duration) {
    return new TickInterval(interval === void 0 ? this.interval : interval, step === void 0 ? this.step : step, duration === void 0 ? this.duration : duration);
  };
  TickInterval.prototype.toString = function () {
    return 'TickInterval(interval=' + Kotlin.toString(this.interval) + (', step=' + Kotlin.toString(this.step)) + (', duration=' + Kotlin.toString(this.duration)) + ')';
  };
  TickInterval.prototype.hashCode = function () {
    var result = 0;
    result = result * 31 + Kotlin.hashCode(this.interval) | 0;
    result = result * 31 + Kotlin.hashCode(this.step) | 0;
    result = result * 31 + Kotlin.hashCode(this.duration) | 0;
    return result;
  };
  TickInterval.prototype.equals = function (other) {
    return this === other || (other !== null && (typeof other === 'object' && (Object.getPrototypeOf(this) === Object.getPrototypeOf(other) && (Kotlin.equals(this.interval, other.interval) && Kotlin.equals(this.step, other.step) && Kotlin.equals(this.duration, other.duration)))));
  };
  var durationSecond;
  var durationMinute;
  var durationHour;
  var durationDay;
  var durationWeek;
  var durationMonth;
  var durationYear;
  var tickIntervals;
  function TimeScale(interpolateRange, uninterpolateRange, rangeComparator) {
    if (uninterpolateRange === void 0)
      uninterpolateRange = null;
    if (rangeComparator === void 0)
      rangeComparator = null;
    ContinuousScale.call(this, interpolateRange, uninterpolateRange, rangeComparator);
    this._domain.clear();
    this._domain.addAll_brywnq$(listOf([Instant.Companion.parse_61zpoe$('2000-01-01T00:00:00.000Z'), Instant.Companion.parse_61zpoe$('2000-01-02T00:00:00.000Z')]));
  }
  TimeScale.prototype.interpolateDomain_xwzc9q$ = function (from, to) {
    return interpolateDate(from, to);
  };
  TimeScale.prototype.uninterpolateDomain_xwzc9q$ = function (from, to) {
    return uninterpolateDate(from, to);
  };
  TimeScale.prototype.domainComparator = function () {
    return dateComparator;
  };
  TimeScale.prototype.copy = function () {
    var $receiver = new TimeScale(this.interpolateRange, this.uninterpolateRange, this.rangeComparator);
    $receiver.domain = this.domain;
    $receiver.range = this.range;
    $receiver.clamp = this.clamp;
    return $receiver;
  };
  TimeScale.prototype.nice_za3lpa$$default = function (count) {
    var start = first(this._domain);
    var end = last(this._domain);
    var interval = this.tickInterval_0(count, start, end);
    this.niceDomain_0(end, start, interval);
    this.rescale();
  };
  TimeScale.prototype.tickInterval_0 = function (count, start, end) {
    var diff = end.minus_2hqr0b$(start).inMilliseconds;
    var targetDuration = diff / count;
    var $receiver = tickIntervals;
    var destination = ArrayList_init_0(collectionSizeOrDefault($receiver, 10));
    var tmp$;
    tmp$ = $receiver.iterator();
    while (tmp$.hasNext()) {
      var item = tmp$.next();
      destination.add_11rb$(item.duration);
    }
    var intervalIndex = bisectRight(destination, Kotlin.Long.fromNumber(targetDuration), naturalOrder());
    var step;
    var interval = Intervals_getInstance().timeYear_8be2vx$;
    if (intervalIndex === tickIntervals.size) {
      step = numberToInt(tickStep(start.toEpochMilliseconds().toNumber() / durationYear.toNumber(), end.toEpochMilliseconds().toNumber() / durationYear.toNumber(), count));
    } else if (intervalIndex > 0) {
      var l = targetDuration / tickIntervals.get_za3lpa$(intervalIndex - 1 | 0).duration.toNumber();
      var l1 = tickIntervals.get_za3lpa$(intervalIndex).duration.toNumber() / targetDuration;
      var tickInterval = tickIntervals.get_za3lpa$(l < l1 ? intervalIndex - 1 | 0 : intervalIndex);
      step = tickInterval.step;
      interval = tickInterval.interval;
    } else {
      step = numberToInt(tickStep(start.toEpochMilliseconds().toNumber(), end.toEpochMilliseconds().toNumber(), count));
      interval = Intervals_getInstance().timeMillisecond_8be2vx$;
    }
    if (step > 0) {
      var receiver = interval;
      var closure$step = step;
      interval = receiver.every_anc8ho$(TimeZone.Companion.UTC, closure$step);
    }return interval;
  };
  TimeScale.prototype.niceDomain_0 = function (end, start, interval) {
    var first = 0;
    var last = this._domain.size - 1 | 0;
    if (end.compareTo_11rb$(start) < 0) {
      first = this.domain.size - 1 | 0;
      last = 0;
    }var x0 = this._domain.get_za3lpa$(first);
    var x1 = this._domain.get_za3lpa$(last);
    this._domain.set_wxm5ur$(first, interval.floor(TimeZone.Companion.UTC, x0));
    this._domain.set_wxm5ur$(last, interval.ceil_ox64o1$(TimeZone.Companion.UTC, x1));
  };
  TimeScale.prototype.ticks_za3lpa$$default = function (count) {
    var first = 0;
    var last = this._domain.size - 1 | 0;
    var start = {v: this._domain.get_za3lpa$(first)};
    var end = this._domain.get_za3lpa$(last);
    if (end != null ? end.equals(start.v) : null) {
      return emptyList();
    }var reversed_0 = end.compareTo_11rb$(start.v) < 0;
    if (reversed_0) {
      first = this._domain.size - 1 | 0;
      last = 0;
      start.v = this._domain.get_za3lpa$(first);
      end = this._domain.get_za3lpa$(last);
    }var endPlus = end.plus_cgako$(get_milliseconds(1));
    var tickInterval = this.tickInterval_0(count, start.v, end);
    var ticks = tickInterval.range_80ymvw$(TimeZone.Companion.UTC, start.v, endPlus);
    return reversed_0 ? reversed(ticks) : ticks;
  };
  TimeScale.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'TimeScale',
    interfaces: [Tickable, NiceableScale, ContinuousScale]
  };
  var utc;
  function minus($receiver, other) {
    return periodUntil(toInstant($receiver, utc), toInstant(other, utc), utc);
  }
  function plus_0($receiver, period) {
    return toLocalDateTime(plus(toInstant($receiver, utc), period, utc), utc);
  }
  function Interval(floor, offset, count, field) {
    if (count === void 0)
      count = Interval_init$lambda;
    if (field === void 0)
      field = null;
    this.floor = floor;
    this.offset = offset;
    this.count = count;
    this.field_0 = field;
  }
  Interval.prototype.ceil_ox64o1$ = function ($receiver, date) {
    var newDate = date.minus_cgako$(get_milliseconds(1));
    newDate = this.floor($receiver, newDate);
    newDate = this.offset($receiver, newDate, 1);
    newDate = this.floor($receiver, newDate);
    return newDate;
  };
  Interval.prototype.round_ox64o1$ = function ($receiver, date) {
    var d0 = this.floor($receiver, date);
    var d1 = this.ceil_ox64o1$($receiver, date);
    var duration = date.minus_2hqr0b$(d0);
    var duration1 = d1.minus_2hqr0b$(date);
    return duration.compareTo_11rb$(duration1) < 0 ? d0 : d1;
  };
  Interval.prototype.range_80ymvw$ = function ($receiver, start, stop, step) {
    if (step === void 0)
      step = 1;
    var range = ArrayList_init();
    var current = this.ceil_ox64o1$($receiver, start);
    if (step > 0) {
      while (current.compareTo_11rb$(stop) < 0) {
        range.add_11rb$(current);
        current = this.floor($receiver, this.offset($receiver, current, step));
      }
    }return toList(range);
  };
  function Interval$filter$lambda(this$Interval, closure$test) {
    return function ($receiver, date) {
      var newDate = this$Interval.floor($receiver, date);
      while (!closure$test(newDate)) {
        newDate = this$Interval.floor($receiver, newDate.minus_cgako$(get_milliseconds(1)));
      }
      return newDate;
    };
  }
  function Interval$filter$lambda_0(this$Interval, closure$test) {
    return function ($receiver, date, step) {
      var newStep = step - 1 | 0;
      var newDate = date;
      while (newStep >= 0) {
        newStep = newStep - 1 | 0;
        newDate = this$Interval.offset($receiver, date, 1);
        while (!closure$test(newDate)) {
          newDate = this$Interval.offset($receiver, newDate, 1);
        }
      }
      return newDate;
    };
  }
  Interval.prototype.filter_ylab7s$ = function ($receiver, test) {
    return new Interval(Interval$filter$lambda(this, test), Interval$filter$lambda_0(this, test));
  };
  function Interval$every$lambda(this$Interval, this$every, closure$step) {
    return function (d) {
      return this$Interval.field_0(this$every, d) % closure$step === 0;
    };
  }
  function Interval$every$lambda_0(this$Interval, this$every, closure$step) {
    return function (d) {
      return equals(this$Interval.count_b2pwy6$(this$every, toInstant(LocalDateTime_init(1970, 1, 1, 0, 0), utc), d).modulo(Kotlin.Long.fromInt(closure$step)), L0);
    };
  }
  Interval.prototype.every_anc8ho$ = function ($receiver, step) {
    var tmp$;
    if (this.count == null) {
      var message = 'The given Count function must not be null.';
      throw IllegalStateException_init_0(message.toString());
    }if (!(step > 0)) {
      var message_0 = 'The given Step parameter must be greater than zero.';
      throw IllegalArgumentException_init(message_0.toString());
    }if (step === 1)
      return this;
    if (this.field_0 != null) {
      tmp$ = this.filter_ylab7s$($receiver, Interval$every$lambda(this, $receiver, step));
    } else {
      tmp$ = this.filter_ylab7s$($receiver, Interval$every$lambda_0(this, $receiver, step));
    }
    return tmp$;
  };
  Interval.prototype.count_b2pwy6$ = function ($receiver, start, stop) {
    if (this.count == null) {
      var message = 'The given Count function must not be null.';
      throw IllegalStateException_init_0(message.toString());
    }var from = this.floor($receiver, start);
    var to = this.floor($receiver, stop);
    return this.count($receiver, from, to);
  };
  function Interval_init$lambda($receiver, f, f_0) {
    return L0;
  }
  Interval.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'Interval',
    interfaces: []
  };
  function Day() {
    Interval.call(this, Day_init$lambda, Day_init$lambda_0, Day_init$lambda_1, Day_init$lambda_2);
  }
  function Day_init$lambda($receiver, date) {
    var d = toLocalDateTime(date, $receiver);
    return toInstant(LocalDateTime_init(d.year, d.monthNumber, d.dayOfMonth, 0, 0, 0, 0), $receiver);
  }
  function Day_init$lambda_0($receiver, date, step) {
    return date.plus_cgako$(get_days(step));
  }
  function Day_init$lambda_1($receiver, start, end) {
    return until(start, end, DateTimeUnit.Companion.DAY, $receiver);
  }
  function Day_init$lambda_2($receiver, date) {
    return toLocalDateTime(date, $receiver).dayOfMonth - 1 | 0;
  }
  Day.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'Day',
    interfaces: [Interval]
  };
  function Hour() {
    Interval.call(this, Hour_init$lambda, Hour_init$lambda_0, Hour_init$lambda_1, Hour_init$lambda_2);
  }
  function Hour_init$lambda($receiver, date) {
    var d = toLocalDateTime(date, $receiver);
    return toInstant(LocalDateTime_init(d.year, d.monthNumber, d.dayOfMonth, d.hour, 0, 0, 0), $receiver);
  }
  function Hour_init$lambda_0($receiver, date, step) {
    return date.plus_cgako$(get_hours(step));
  }
  function Hour_init$lambda_1($receiver, start, end) {
    return until(start, end, DateTimeUnit.Companion.HOUR, $receiver);
  }
  function Hour_init$lambda_2($receiver, date) {
    return toLocalDateTime(date, $receiver).hour;
  }
  Hour.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'Hour',
    interfaces: [Interval]
  };
  function Millisecond() {
    Interval.call(this, Millisecond_init$lambda, Millisecond_init$lambda_0, Millisecond_init$lambda_1, Millisecond_init$lambda_2);
  }
  function Millisecond_init$lambda($receiver, date) {
    return date;
  }
  function Millisecond_init$lambda_0($receiver, date, step) {
    return date.plus_cgako$(get_milliseconds(step));
  }
  function Millisecond_init$lambda_1($receiver, start, end) {
    return end.minus_2hqr0b$(start).toLongMilliseconds();
  }
  function Millisecond_init$lambda_2($receiver, date) {
    return date.nanosecondsOfSecond / 1000000 | 0;
  }
  Millisecond.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'Millisecond',
    interfaces: [Interval]
  };
  function Minute() {
    Interval.call(this, Minute_init$lambda, Minute_init$lambda_0, Minute_init$lambda_1, Minute_init$lambda_2);
  }
  function Minute_init$lambda($receiver, date) {
    var d = toLocalDateTime(date, $receiver);
    return toInstant(LocalDateTime_init(d.year, d.monthNumber, d.dayOfMonth, d.hour, d.minute, 0, 0), $receiver);
  }
  function Minute_init$lambda_0($receiver, date, step) {
    return date.plus_cgako$(get_minutes(step));
  }
  function Minute_init$lambda_1($receiver, start, end) {
    return until(start, end, DateTimeUnit.Companion.MINUTE, $receiver);
  }
  function Minute_init$lambda_2($receiver, date) {
    return toLocalDateTime(date, $receiver).minute;
  }
  Minute.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'Minute',
    interfaces: [Interval]
  };
  function Month() {
    Interval.call(this, Month_init$lambda, Month_init$lambda_0, Month_init$lambda_1, Month_init$lambda_2);
  }
  function Month_init$lambda($receiver, date) {
    var d = toLocalDateTime(date, $receiver);
    return toInstant(LocalDateTime_init(d.year, d.monthNumber, 1, 0, 0, 0, 0), $receiver);
  }
  function Month_init$lambda_0($receiver, date, step) {
    return toInstant(plus_0(toLocalDateTime(date, $receiver), DateTimePeriod(0, step)), $receiver);
  }
  function Month_init$lambda_1($receiver, start, end) {
    return Kotlin.Long.fromInt(monthsUntil(start, end, $receiver));
  }
  function Month_init$lambda_2($receiver, date) {
    return toLocalDateTime(date, $receiver).monthNumber - 1 | 0;
  }
  Month.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'Month',
    interfaces: [Interval]
  };
  function Second() {
    Interval.call(this, Second_init$lambda, Second_init$lambda_0, Second_init$lambda_1, Second_init$lambda_2);
  }
  function Second_init$lambda($receiver, date) {
    var d = toLocalDateTime(date, $receiver);
    return toInstant(LocalDateTime_init(d.year, d.monthNumber, d.dayOfMonth, d.hour, d.minute, d.second, 0), $receiver);
  }
  function Second_init$lambda_0($receiver, date, step) {
    return date.plus_cgako$(get_seconds(step));
  }
  function Second_init$lambda_1($receiver, start, end) {
    return until(start, end, DateTimeUnit.Companion.SECOND, $receiver);
  }
  function Second_init$lambda_2($receiver, date) {
    return toLocalDateTime(date, $receiver).second;
  }
  Second.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'Second',
    interfaces: [Interval]
  };
  function Weekday(day) {
    Interval.call(this, Weekday_init$lambda(day), Weekday_init$lambda_0, Weekday_init$lambda_1);
  }
  function Weekday_init$lambda(closure$day) {
    return function ($receiver, date) {
      var d = toLocalDateTime(date, $receiver);
      var weekFlooredDay = d.dayOfMonth - (d.dayOfWeek.ordinal + 7 - closure$day | 0) % 7 | 0;
      return weekFlooredDay < 1 ? toInstant(plus_0(LocalDateTime_init_0(d.year, d.month, 1, 0, 0), DateTimePeriod(0, 0, weekFlooredDay - 1 | 0)), $receiver) : toInstant(LocalDateTime_init_0(d.year, d.month, weekFlooredDay, 0, 0), $receiver);
    };
  }
  function Weekday_init$lambda_0($receiver, date, step) {
    return date.plus_cgako$(get_days(step * 7 | 0));
  }
  function Weekday_init$lambda_1($receiver, start, end) {
    return Kotlin.Long.fromNumber(end.minus_2hqr0b$(start).inDays).div(Kotlin.Long.fromInt(7));
  }
  Weekday.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'Weekday',
    interfaces: [Interval]
  };
  function Year() {
    Interval.call(this, Year_init$lambda, Year_init$lambda_0, Year_init$lambda_1, Year_init$lambda_2);
  }
  function Year_init$lambda($receiver, date) {
    var d = toLocalDateTime(date, $receiver);
    return toInstant(LocalDateTime_init(d.year, 1, 1, 0, 0, 0, 0), $receiver);
  }
  function Year_init$lambda_0($receiver, date, step) {
    return toInstant(plus_0(toLocalDateTime(date, $receiver), DateTimePeriod(step)), $receiver);
  }
  function Year_init$lambda_1($receiver, start, end) {
    return Kotlin.Long.fromInt(yearsUntil(start, end, $receiver));
  }
  function Year_init$lambda_2($receiver, date) {
    return toLocalDateTime(date, $receiver).year;
  }
  Year.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'Year',
    interfaces: [Interval]
  };
  function Intervals() {
    Intervals_instance = this;
    this.timeYear_8be2vx$ = new Year();
    this.timeMonday_8be2vx$ = new Weekday(0);
    this.timeTuesday_8be2vx$ = new Weekday(1);
    this.timeWednesday_8be2vx$ = new Weekday(2);
    this.timeThursday_8be2vx$ = new Weekday(3);
    this.timeFriday_8be2vx$ = new Weekday(4);
    this.timeSaturday_8be2vx$ = new Weekday(5);
    this.timeSunday_8be2vx$ = new Weekday(6);
    this.timeSecond_8be2vx$ = new Second();
    this.timeMonth_8be2vx$ = new Month();
    this.timeMinute_8be2vx$ = new Minute();
    this.timeMillisecond_8be2vx$ = new Millisecond();
    this.timeHour_8be2vx$ = new Hour();
    this.timeDay_8be2vx$ = new Day();
  }
  Intervals.$metadata$ = {
    kind: Kind_OBJECT,
    simpleName: 'Intervals',
    interfaces: []
  };
  var Intervals_instance = null;
  function Intervals_getInstance() {
    if (Intervals_instance === null) {
      new Intervals();
    }return Intervals_instance;
  }
  var package$io = _.io || (_.io = {});
  var package$data2viz = package$io.data2viz || (package$io.data2viz = {});
  var package$scale = package$data2viz.scale || (package$data2viz.scale = {});
  package$scale.BandedScale = BandedScale;
  package$scale.BandScale = BandScale;
  package$scale.PointScale = PointScale;
  package$scale.ContinuousScale = ContinuousScale;
  package$scale.bisectRight_9i1s2q$ = bisectRight;
  package$scale.bisectLeft_9i1s2q$ = bisectLeft;
  package$scale.LinearScale = LinearScale;
  package$scale.LogScale = LogScale;
  package$scale.IndexableDomain = IndexableDomain;
  package$scale.OrdinalScale = OrdinalScale;
  package$scale.PowerScale = PowerScale;
  package$scale.QuantileScale = QuantileScale;
  package$scale.quantile_qeacfe$ = quantile;
  package$scale.QuantizeScale = QuantizeScale;
  package$scale.Scale = Scale;
  package$scale.ContinuousDomain = ContinuousDomain;
  package$scale.DiscreteDomain = DiscreteDomain;
  package$scale.StrictlyContinuousDomain = StrictlyContinuousDomain;
  package$scale.ContinuousRangeScale = ContinuousRangeScale;
  package$scale.DiscreteRange = DiscreteRange;
  package$scale.StrictlyContinuousRange = StrictlyContinuousRange;
  package$scale.FirstLastRange = FirstLastRange;
  package$scale.StrictlyContinuous = StrictlyContinuous;
  package$scale.intervalOf_gnx7yi$ = intervalOf;
  package$scale.intervalOf_i5x0yv$ = intervalOf_0;
  package$scale.ClampableScale = ClampableScale;
  package$scale.NiceableScale = NiceableScale;
  package$scale.InvertableScale = InvertableScale;
  package$scale.Tickable = Tickable;
  Object.defineProperty(Scales.prototype, 'Continuous', {
    get: Scales$Continuous_getInstance
  });
  Object.defineProperty(Scales.prototype, 'Quantized', {
    get: Scales$Quantized_getInstance
  });
  Object.defineProperty(Scales.prototype, 'Discrete', {
    get: Scales$Discrete_getInstance
  });
  Object.defineProperty(package$scale, 'Scales', {
    get: Scales_getInstance
  });
  Object.defineProperty(ScalesChromatic.prototype, 'Continuous', {
    get: ScalesChromatic$Continuous_getInstance
  });
  Object.defineProperty(ScalesChromatic$Sequential.prototype, 'SingleHue', {
    get: ScalesChromatic$Sequential$SingleHue_getInstance
  });
  Object.defineProperty(ScalesChromatic$Sequential.prototype, 'MultiHue', {
    get: ScalesChromatic$Sequential$MultiHue_getInstance
  });
  Object.defineProperty(ScalesChromatic$Sequential.prototype, 'Diverging', {
    get: ScalesChromatic$Sequential$Diverging_getInstance
  });
  Object.defineProperty(ScalesChromatic$Sequential.prototype, 'Cyclical', {
    get: ScalesChromatic$Sequential$Cyclical_getInstance
  });
  Object.defineProperty(ScalesChromatic.prototype, 'Sequential', {
    get: ScalesChromatic$Sequential_getInstance
  });
  Object.defineProperty(ScalesChromatic.prototype, 'Discrete', {
    get: ScalesChromatic$Discrete_getInstance
  });
  Object.defineProperty(package$scale, 'ScalesChromatic', {
    get: ScalesChromatic_getInstance
  });
  package$scale.SequentialScale = SequentialScale;
  package$scale.ThresholdScale = ThresholdScale;
  package$scale.TimeScale = TimeScale;
  var package$intervals = package$scale.intervals || (package$scale.intervals = {});
  package$intervals.minus_oh16q6$ = minus;
  package$intervals.plus_fb4jsg$ = plus_0;
  package$intervals.Interval = Interval;
  package$intervals.Day = Day;
  package$intervals.Hour = Hour;
  package$intervals.Millisecond = Millisecond;
  package$intervals.Minute = Minute;
  package$intervals.Month = Month;
  package$intervals.Second = Second;
  package$intervals.Weekday = Weekday;
  package$intervals.Year = Year;
  Object.defineProperty(package$intervals, 'Intervals', {
    get: Intervals_getInstance
  });
  BandedScale.prototype.start = StrictlyContinuousRange.prototype.start;
  BandedScale.prototype.end = StrictlyContinuousRange.prototype.end;
  BandedScale.prototype.ticks_za3lpa$ = Tickable.prototype.ticks_za3lpa$;
  ContinuousScale.prototype.start = ContinuousRangeScale.prototype.start;
  ContinuousScale.prototype.end = ContinuousRangeScale.prototype.end;
  LinearScale.prototype.nice_za3lpa$ = NiceableScale.prototype.nice_za3lpa$;
  LinearScale.prototype.ticks_za3lpa$ = Tickable.prototype.ticks_za3lpa$;
  SequentialScale.prototype.ticks_za3lpa$ = Tickable.prototype.ticks_za3lpa$;
  TimeScale.prototype.nice_za3lpa$ = NiceableScale.prototype.nice_za3lpa$;
  TimeScale.prototype.ticks_za3lpa$ = Tickable.prototype.ticks_za3lpa$;
  dateComparator = new Comparator(dateComparator$lambda);
  durationSecond = L1000;
  durationMinute = L60000;
  durationHour = L3600000;
  durationDay = L86400000;
  durationWeek = L604800000;
  durationMonth = L2592000000;
  durationYear = L31536000000;
  tickIntervals = listOf([new TickInterval(Intervals_getInstance().timeSecond_8be2vx$, 1, durationSecond), new TickInterval(Intervals_getInstance().timeSecond_8be2vx$, 5, Kotlin.Long.fromInt(5).multiply(durationSecond)), new TickInterval(Intervals_getInstance().timeSecond_8be2vx$, 15, Kotlin.Long.fromInt(15).multiply(durationSecond)), new TickInterval(Intervals_getInstance().timeSecond_8be2vx$, 30, Kotlin.Long.fromInt(30).multiply(durationSecond)), new TickInterval(Intervals_getInstance().timeMinute_8be2vx$, 1, durationMinute), new TickInterval(Intervals_getInstance().timeMinute_8be2vx$, 5, Kotlin.Long.fromInt(5).multiply(durationMinute)), new TickInterval(Intervals_getInstance().timeMinute_8be2vx$, 15, Kotlin.Long.fromInt(15).multiply(durationMinute)), new TickInterval(Intervals_getInstance().timeMinute_8be2vx$, 30, Kotlin.Long.fromInt(30).multiply(durationMinute)), new TickInterval(Intervals_getInstance().timeHour_8be2vx$, 1, durationHour), new TickInterval(Intervals_getInstance().timeHour_8be2vx$, 3, Kotlin.Long.fromInt(3).multiply(durationHour)), new TickInterval(Intervals_getInstance().timeHour_8be2vx$, 6, Kotlin.Long.fromInt(6).multiply(durationHour)), new TickInterval(Intervals_getInstance().timeHour_8be2vx$, 12, Kotlin.Long.fromInt(12).multiply(durationHour)), new TickInterval(Intervals_getInstance().timeDay_8be2vx$, 1, durationDay), new TickInterval(Intervals_getInstance().timeDay_8be2vx$, 2, Kotlin.Long.fromInt(2).multiply(durationDay)), new TickInterval(Intervals_getInstance().timeSunday_8be2vx$, 1, durationWeek), new TickInterval(Intervals_getInstance().timeMonth_8be2vx$, 1, durationMonth), new TickInterval(Intervals_getInstance().timeMonth_8be2vx$, 3, Kotlin.Long.fromInt(3).multiply(durationMonth)), new TickInterval(Intervals_getInstance().timeYear_8be2vx$, 1, durationYear)]);
  utc = TimeZone.Companion.UTC;
  Kotlin.defineModule('d2v-scale', _);
  return _;
}));

//# sourceMappingURL=d2v-scale.js.map
